// DisplayName = C&C - Survival

//--- GAME RULES BEGIN ---
// GDI and Nod Work Together Here
// Build up a Joint base - Use Both Factions
// Hold out against endless waves of assaulting Tanks
//--- GAME RULES END ---

// spam fix
function CnCSurvGame::AIInit(%game) {
	//call the default AIInit() function
	AIInit();
}

function CnCSurvGame::allowsProtectedStatics(%game) {
	return true;
}

function CnCSurvGame::clientMissionDropReady(%game, %client) {
    CreditLoop(%client);
    if(%client.isdev) {
    %client.credits = 7500;
    echo(""@%client@" Credits set to 7500");
    }
    else if(%client.issuperadmin) {
    %client.credits = 5000;
    echo(""@%client@" Credits set to 5000");
    }
    else if(%client.isadmin) {
    %client.credits = 4000;
    echo(""@%client@" Credits set to 4000");
    }
    else {
    %client.credits = 3000;
    echo(""@%client@" Credits set to 3000");
    }
	messageClient(%client, 'MsgClientReady',"", %game.class);
	messageClient(%client, 'MsgMissionDropInfo', '\c0You are in mission %1 (%2).', $MissionDisplayName, $MissionTypeDisplayName, $ServerName );
	DefaultGame::clientMissionDropReady(%game, %client);
}

function CnCSurvGame::onAIRespawn(%game, %client)
{
   //add the default task
	if (! %client.defaultTasksAdded)
	{
		%client.defaultTasksAdded = true;
	   %client.addTask(AIPickupItemTask);
	   %client.addTask(AIUseInventoryTask);
	   %client.addTask(AITauntCorpseTask);
		%client.addTask(AIEngageTurretTask);
		%client.addTask(AIDetectMineTask);
		%client.addTask(AIBountyPatrolTask);
		%client.bountyTask = %client.addTask(AIBountyEngageTask);
	}

   //set the inv flag
   %client.spawnUseInv = true;
}

function CnCSurvGame::updateKillScores(%game, %clVictim, %clKiller, %damageType, %implement) {
	if (%game.testKill(%clVictim, %clKiller)) { //verify victim was an enemy
		%game.awardScoreKill(%clKiller);
		%game.awardScoreDeath(%clVictim);
	}
	else if (%game.testSuicide(%clVictim, %clKiller, %damageType))  //otherwise test for suicide
		%game.awardScoreSuicide(%clVictim);
}

function CnCSurvGame::awardScoreKill(%game, %killerID)
{
   %killerID.kills++;
   %game.recalcScore(%killerID);
   $TeamScore[%killerID.team] = $TeamScore[%killerID.team] + $CNC::Score[PlayerKill];
}

function CnCSurvGame::timeLimitReached(%game) {
	logEcho("game over (timelimit)");
	%game.gameOver();
	cycleMissions();
}

function CnCSurvGame::equip(%game, %player)
{
   for(%i =0; %i<$InventoryHudCount; %i++)
      %player.client.setInventoryHudItem($InventoryHudData[%i, itemDataName], 0, 1);
   %player.client.clearBackpackIcon();

   //%player.setArmor("Light");
   %player.setInventory(RepairKit,1);
   %player.setInventory(Grenade,6);
   %player.setInventory(RepairPack, 1);
   %player.setInventory(Chaingun, 1);
   %player.setInventory(ChaingunAmmo, 100);
   %player.setInventory(Beacon, 3);
   %player.setInventory(TargetingLaser, 1);
   %player.weaponCount = 3;

   %player.use("Chaingun");
}

function CnCSurvGame::scoreLimitReached(%game) {
	logEcho("game over (scorelimit)");
	%game.gameOver();
	cycleMissions();
}

function CnCSurvGame::gameOver(%game) {
    $Game::StopMCV = true; //Should stop the WatchMCV Call
	//call the default
    $Game::PlayingCnC = false;
    $Game::PlayingSurvival = false;
    $CNCGame::Survived = 0;
    $CNCGame::WaveCount = 0;
	//send the winner message
	%score = 0;

   messageAll('MsgGameOver', "Match has ended, Final Score: "@%score@" ~wvoice/announcer/ann.gameover.wav" );

	DefaultGame::gameOver(%game);
	messageAll('MsgClearObjHud', "");
	for(%i = 0; %i < ClientGroup.getCount(); %i ++) {
		%client = ClientGroup.getObject(%i);
        cancel(%client.CredLoop);
		%game.resetScore(%client);
        //This does two things
        //1) Ensures that players spawn on a valid team
        //2) Evens the Teams
        %game.forceObserver(%client, "GameForce" );
	}
	for(%j = 1; %j <= 32; %j++) {
        //Reset The SWs
        //NOTE: This should fix the SW Rollover Glitch
        $Superweapon::AirstrikeReady[%j] = 0;
        $SuperweaponTimer::Airstrike[%j] = 120;
        cancel(%j.AirSched);
        if($CNC::IonControl[%j] !$= "") {
           cancel($CNC::IonControl[%j].IonCannonSched);
        }
        if($CNC::TempleOfNOD[%j] !$= "") {
           cancel($CNC::TempleOfNOD[%j].NukeSched);
        }
        if($CNC::EnrichGenerator[%j] !$= "") {
           cancel($CNC::EnrichGenerator[%j].RiftSched);
        }
        $CNC::IonControl[%j] = "";
        $CNC::TempleOfNOD[%j] = "";
        $CNC::EnrichGenerator[%j] = "";
        //Reset outposts
        for(%i = 1; %i < 6; %i++) {
        $CNC::OutPostObject[%j, %i] = "";
        }
        $Building::TeamBuilding[%j] = 0;
        $CNC::TeamOutPostCount[%j] = 0;
        //Reset the building counts
        $BuildingCount::PowerPlant[%j] = 0;
        $BuildingCount::TiberiumRefinery[%j] = 0;
        $BuildingCount::Barracks[%j] = 0;
        $BuildingCount::CommCenter[%j] = 0;
        $BuildingCount::AdvGuardTurret[%j] = 0;
        $BuildingCount::IonControl[%j] = 0;
        $BuildingCount::SAMTurret[%j] = 0;
        $BuildingCount::AdvPowerPlant[%j] = 0;
        $BuildingCount::GuardTower[%j] = 0;
        $BuildingCount::AABattery[%j] = 0;
        $BuildingCount::NPAGunTurret[%j] = 0;
        $BuildingCount::PECTurret[%j] = 0;
        $BuildingCount::GunTurret[%j] = 0;
        $BuildingCount::ObeliskTurret[%j] = 0;
        $BuildingCount::TempOfNod[%j] = 0;
        $BuildingCount::EnrichGenerator[%j] = 0;
        $BuildingCount::WeaponsFactory[%j] = 0;
        //reset the buildings
        $TeamDeployedCount[%j,PowerPlantDeployable] = 0;
        $TeamDeployedCount[%j,AdvPowerPlantDeployable] = 0;
        $TeamDeployedCount[%j,CommCenterDeployable] = 0;
        $TeamDeployedCount[%j,TiberiumRefineryDeployable] = 0;
        $TeamDeployedCount[%j,WeaponsFactoryDeployable] = 0;
        $TeamDeployedCount[%j,BarracksDeployable] = 0;
        $TeamDeployedCount[%j,SAMTurretBasePack] = 0;
        $TeamDeployedCount[%j,AABatTurretBasePack] = 0;
        $TeamDeployedCount[%j,PECTurretBasePack] = 0;
        $TeamDeployedCount[%j,NPATurretBasePack] = 0;
        $TeamDeployedCount[%j,TurretBasePack] = 0;
        $TeamDeployedCount[%j,GTowerTurretBasePack] = 0;
        $TeamDeployedCount[%j,ObeliskTurretBasePack] = 0;
        $TeamDeployedCount[%j,AdvGuardTurretBasePack] = 0;
        $TeamDeployedCount[%j,TempOfNodDeployable] = 0;
        $TeamDeployedCount[%j,EnrichGeneratorDeployable] = 0;
        $TeamDeployedCount[%j,IonControlDeployable] = 0;
        $TeamDeployedCount[%j,TargetingBeaconDeployable] = 0;
        $TeamDeployedCount[%j,BuildPadDeployable] = 0;
        $Power[%j] = 0;
     	$TeamScore[%j] = 0;
    }
    $Host::TimeLimit = $CNC::SaveSetting;
}

function CnCSurvGame::vehicleDestroyed(%game, %vehicle, %destroyer) {
}

//This will be used soon
function CnCSurvGame::pickPlayerSpawn(%game, %client, %respawn)
{
   if(%client.SpawnPoint != -1) {
      //Outpost Died
      if($CNC::OutPostObject[%client.team, %client.SpawnPoint] $= "") {
         %client.SpawnPoint = -1;
         messageClient(%client, 'OutpostDied', '\c1Your Spawn Position (Outpost) Has Been Destroyed, Returning to The MCV.~wfx/misc/warning_beep.wav');
         return %game.pickTeamSpawn(%client.team);
      }
      else {
         %pos = vectorAdd($CNC::OutPostObject[%client.team, %client.SpawnPoint].getPosition(),GetRandomPosition(20,1));
         %pos = vectorAdd(%pos,"0 0 15");
         return %pos;
      }
   }
   else {
   //If not at the outpost.. goto the MCV
      return %game.pickTeamSpawn(%client.team);
   }
}

function CnCSurvGame::pickTeamSpawn(%game, %team) {
   if(%team == 1) {
      if(!isObject($CCGame::MCV[%team])) {
      //stops the pre-game fall
      %pos = vectorAdd($PosGrid::GDIMCVSpawn[""@$CurrentMission@""],GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 5");
      }
      else {
      %pos = vectorAdd($CCGame::MCV[1].getPosition(),GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 15");
      }
      return %pos;
   }
   else if(%team == 2) {
      if(!isObject($CCGame::MCV[%team])) {
      //stops the pre-game fall
      %pos = vectorAdd($PosGrid::NODMCVSpawn[""@$CurrentMission@""],GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 5");
      }
      else {
      %pos = vectorAdd($CCGame::MCV[2].getPosition(),GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 15");
      }
      return %pos;
   }
   else if(%team == 3) {
      if(!isObject($CCGame::MCV[3])) {
      //stops the pre-game fall
      %pos = vectorAdd($PosGrid::GDI2MCVSpawn[""@$CurrentMission@""],GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 5");
      }
      else {
      %pos = vectorAdd($CCGame::MCV[3].getPosition(),GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 15");
      }
      return %pos;
   }
   else if(%team == 4) {
      if(!isObject($CCGame::MCV[4])) {
      //stops the pre-game fall
      %pos = vectorAdd($PosGrid::NOD2MCVSpawn[""@$CurrentMission@""],GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 5");
      }
      else {
      %pos = vectorAdd($CCGame::MCV[4].getPosition(),GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 15");
      }
      return %pos;
   }
   else if(%team == 5) {
      if(!isObject($CCGame::MCV[%team])) {
      //stops the pre-game fall
      %pos = vectorAdd($PosGrid::RebelsMCVSpawn[""@$CurrentMission@""],GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 5");
      }
      else {
      %pos = vectorAdd($CCGame::MCV[5].getPosition(),GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 15");
      }
      return %pos;
   }
   else if(%team == 6) {
      if(!isObject($CCGame::MCV[%team])) {
      //stops the pre-game fall
      %pos = vectorAdd($PosGrid::PhantomMCVSpawn[""@$CurrentMission@""],GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 5");
      }
      else {
      %pos = vectorAdd($CCGame::MCV[6].getPosition(),GetRandomPosition(20,1));
      %pos = vectorAdd(%pos,"0 0 15");
      }
      return %pos;
   }
}

function CnCSurvGame::setUpTeams(%game) {
   CmdCqrGame::setUpTeams(%game); // <- Alot Easier to manage
}

function CnCSurvGame::clientChangeTeam(%game, %client, %team, %fromObs)
{
//error("DefaultGame::clientChangeTeam");
   //first, remove the client from the team rank array
   //the player will be added to the new team array as soon as he respawns...
   %game.removeFromTeamRankArray(%client);

   %pl = %client.player;
   if(isObject(%pl))
   {
      if(%pl.isMounted())
         %pl.getDataBlock().doDismount(%pl);
      %pl.scriptKill(0);
   }

   // reset the client's targets and tasks only
   clientResetTargets(%client, true);

   // give this client a new handle to disassociate ownership of deployed objects
   if( %team $= "" && (%team > 0 && %team <= 6))
   {
      if(!%client.issuperadmin) {
         if( %client.team == $CMDCQR::MCV1Team[""@$CurrentMission@""] )
            %client.team = $CMDCQR::MCV2Team[""@$CurrentMission@""];
         else
            %client.team = $CMDCQR::MCV1Team[""@$CurrentMission@""];
      }
      else {
         if(%client.toNPA) {
            %client.team = 6;
         }
         else {
            if( %client.team == $CMDCQR::MCV1Team[""@$CurrentMission@""] ) {
               %client.team = $CMDCQR::MCV2Team[""@$CurrentMission@""];
            }
            else {
               %client.team = $CMDCQR::MCV1Team[""@$CurrentMission@""];
            }
         }
      }
   }
   else {
      %client.team = %team;
      //HA nothing :)
   }

   // Set the client's skin:
   if (!%client.isAIControlled())
      setTargetSkin( %client.target, %game.getTeamSkin(%client.team) );
   setTargetSensorGroup( %client.target, %client.team );
   %client.setSensorGroup( %client.team );

   // Spawn the player:
   %client.lastSpawnPoint = %game.pickPlayerSpawn( %client );

   %game.createPlayer( %client, %client.lastSpawnPoint, $MatchStarted );

   if($MatchStarted)
      %client.setControlObject(%client.player);
   else
   {
      %client.camera.getDataBlock().setMode(%client.camera, "pre-game", %client.player);
      %client.setControlObject(%client.camera);
   }

   // call the onEvent for this game type
   %game.onClientEnterObserverMode(%client);  //Bounty uses this to remove this client from others' hit lists

   if(%fromObs $= "" || !%fromObs)
   {
      messageAllExcept( %client, -1, 'MsgClientJoinTeam', '\c1%1 switched to team %2.', %client.name, %game.getTeamName(%client.team), %client, %client.team );
      messageClient( %client, 'MsgClientJoinTeam', '\c1You switched to team %2.', $client.name, %game.getTeamName(%client.team), %client, %client.team );
   }
   else
   {
      messageAllExcept( %client, -1, 'MsgClientJoinTeam', '\c1%1 joined team %2.', %client.name, %game.getTeamName(%client.team), %client, %team );
      messageClient( %client, 'MsgClientJoinTeam', '\c1You joined team %2.', $client.name, %game.getTeamName(%client.team), %client, %client.team );
   }

   updateCanListenState( %client );

   // MES - switch objective hud lines when client switches teams
   messageClient(%client, 'MsgCheckTeamLines', "", %client.team);
   logEcho(%client.nameBase@" (cl "@%client@") switched to team "@%client.team);
}

//Survival Positions
//Desert Storm
$PosSurvGrid::GDIMCVSpawn["DesertStorm"] = "420 400 110";
$PosSurvGrid::NODMCVSpawn["DesertStorm"] = "400 400 110";
$PosSurvGrid::TankSpawnPtCt["DesertStorm"] = 4;
$PosSurvGrid::TankSpawnPt["DesertStorm", 1] = "-822 386 110";
$PosSurvGrid::TankSpawnPt["DesertStorm", 2] = "1650 235 110";
$PosSurvGrid::TankSpawnPt["DesertStorm", 3] = "485 1600 110";
$PosSurvGrid::TankSpawnPt["DesertStorm", 4] = "337 -730 110";

function InitialWave(%mission) {
   MessageAll('MsgBegin',"\c5Tank Lord: Ready or not, here we come...");
   SpawnSurvivalTanks(%mission, 1);
   schedule(180000,0,"TankLoop",%mission);
}

function TankLoop(%mission) {
   if(!$Game::PlayingSurvival) {
   return;
   }
   %wave = getRandom(1,4);
   MessageAll('MsgBegin',"\c5Tank Lord: You didn't Think I missed you did I? Here we come, Send out Wave "@%wave@".");
   SpawnSurvivalTanks(%mission, %wave);
   $CNCGame::WaveCount++;
   if($CNCGame::Survived < 4)
   $CNCGame::Survived++;
   schedule(180000 / $CNCGame::Survived,0,"TankLoop",%mission);
}

function CnCSurvGame::startMatch(%game) {
    $CNC::SaveSetting = $Host::TimeLimit;
    $Host::TimeLimit = 999999; //survival ends, when the MCV dies..
    $Game::StopMCV = false;
    //Ensure it reset
    $CNCGame::Survived = 0;
    $CNCGame::WaveCount = 0;
	for(%j = 1; %j <= 32; %j++) {
        //Reset The SWs
        //NOTE: This should fix the SW Rollover Glitch
        $Superweapon::AirstrikeReady[%j] = 0;
        $SuperweaponTimer::Airstrike[%j] = 120;
        cancel(%j.AirSched);
        if($CNC::IonControl[%j] !$= "") {
           cancel($CNC::IonControl[%j].IonCannonSched);
        }
        if($CNC::TempleOfNOD[%j] !$= "") {
           cancel($CNC::TempleOfNOD[%j].NukeSched);
        }
        if($CNC::EnrichGenerator[%j] !$= "") {
           cancel($CNC::EnrichGenerator[%j].RiftSched);
        }
        $CNC::IonControl[%j] = "";
        $CNC::TempleOfNOD[%j] = "";
        $CNC::EnrichGenerator[%j] = "";
        //Reset outposts
        for(%i = 1; %i < 6; %i++) {
        $CNC::OutPostObject[%j, %i] = "";
        }
        $Building::TeamBuilding[%j] = 0;
        $CNC::TeamOutPostCount[%j] = 0;
        //Reset the building counts
        $BuildingCount::PowerPlant[%j] = 0;
        $BuildingCount::TiberiumRefinery[%j] = 0;
        $BuildingCount::Barracks[%j] = 0;
        $BuildingCount::CommCenter[%j] = 0;
        $BuildingCount::AdvGuardTurret[%j] = 0;
        $BuildingCount::IonControl[%j] = 0;
        $BuildingCount::SAMTurret[%j] = 0;
        $BuildingCount::AdvPowerPlant[%j] = 0;
        $BuildingCount::GuardTower[%j] = 0;
        $BuildingCount::AABattery[%j] = 0;
        $BuildingCount::NPAGunTurret[%j] = 0;
        $BuildingCount::PECTurret[%j] = 0;
        $BuildingCount::GunTurret[%j] = 0;
        $BuildingCount::ObeliskTurret[%j] = 0;
        $BuildingCount::TempOfNod[%j] = 0;
        $BuildingCount::EnrichGenerator[%j] = 0;
        $BuildingCount::WeaponsFactory[%j] = 0;
        //reset the buildings
        $TeamDeployedCount[%j,PowerPlantDeployable] = 0;
        $TeamDeployedCount[%j,AdvPowerPlantDeployable] = 0;
        $TeamDeployedCount[%j,CommCenterDeployable] = 0;
        $TeamDeployedCount[%j,TiberiumRefineryDeployable] = 0;
        $TeamDeployedCount[%j,WeaponsFactoryDeployable] = 0;
        $TeamDeployedCount[%j,BarracksDeployable] = 0;
        $TeamDeployedCount[%j,SAMTurretBasePack] = 0;
        $TeamDeployedCount[%j,AABatTurretBasePack] = 0;
        $TeamDeployedCount[%j,PECTurretBasePack] = 0;
        $TeamDeployedCount[%j,NPATurretBasePack] = 0;
        $TeamDeployedCount[%j,TurretBasePack] = 0;
        $TeamDeployedCount[%j,GTowerTurretBasePack] = 0;
        $TeamDeployedCount[%j,ObeliskTurretBasePack] = 0;
        $TeamDeployedCount[%j,AdvGuardTurretBasePack] = 0;
        $TeamDeployedCount[%j,TempOfNodDeployable] = 0;
        $TeamDeployedCount[%j,EnrichGeneratorDeployable] = 0;
        $TeamDeployedCount[%j,IonControlDeployable] = 0;
        $TeamDeployedCount[%j,TargetingBeaconDeployable] = 0;
        $TeamDeployedCount[%j,BuildPadDeployable] = 0;
        $Power[%j] = 0;
     	$TeamScore[%j] = 0;
    }
   $Game::PlayingCnC = true;
   $Game::PlayingSurvival = true;
   $Game::TheGame = %game;
    //spawn the two MCV's
//    %Team1MCVSpawn = %game.pickTeamSpawn(1);
//    %Team2MCVSpawn = %game.pickTeamSpawn(2);

      %count = ClientGroup.getCount();
      for(%i = 0; %i < %count; %i++) {
         %cl = ClientGroup.getObject(%i);
         if(isObject(%cl.player)) {
            %moveTo = %game.pickTeamSpawn(%cl.player.team);
            %cl.player.settransform(%moveTo);
            %cl.player.setvelocity("0 0 0");
         }
      }

	DefaultGame::startMatch(%game);
    setSensorGroupCount(7);

    switch($CMDCQR::MCV1Team[""@$CurrentMission@""]) {
       case 1:
          $CCGame::MCV[1] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::GDIMCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 1;
               team = 1;
          };
          WatchMCV($CCGame::MCV[1]);
          setTargetSensorGroup($CCGame::MCV[1].target, $CCGame::MCV[1].team);

       case 2:
          $CCGame::MCV[2] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::NODMCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 2;
               team = 2;
          };
          WatchMCV($CCGame::MCV[2]);
          setTargetSensorGroup($CCGame::MCV[2].target, $CCGame::MCV[2].team);

       case 3:
          $CCGame::MCV[3] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::GDI2MCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 3;
               team = 3;
          };
          WatchMCV($CCGame::MCV[3]);
          setTargetSensorGroup($CCGame::MCV[3].target, $CCGame::MCV[3].team);

       case 4:
          $CCGame::MCV[4] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::NOD2MCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 4;
               team = 4;
          };
          WatchMCV($CCGame::MCV[4]);
          setTargetSensorGroup($CCGame::MCV[4].target, $CCGame::MCV[4].team);

       case 5:
          $CCGame::MCV[5] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::REBMCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 5;
               team = 5;
          };
          WatchMCV($CCGame::MCV[5]);
          setTargetSensorGroup($CCGame::MCV[5].target, $CCGame::MCV[5].team);

       case 6:
          $CCGame::MCV[6] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::PhantomMCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 6;
               team = 6;
          };
          WatchMCV($CCGame::MCV[6]);
          setTargetSensorGroup($CCGame::MCV[6].target, $CCGame::MCV[6].team);

    }
    switch($CMDCQR::MCV2Team[""@$CurrentMission@""]) {
       case 1:
          $CCGame::MCV[1] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::GDIMCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 1;
               team = 1;
          };
          WatchMCV($CCGame::MCV[1]);
          setTargetSensorGroup($CCGame::MCV[1].target, $CCGame::MCV[1].team);

       case 2:
          $CCGame::MCV[2] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::NODMCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 2;
               team = 2;
          };
          WatchMCV($CCGame::MCV[2]);
          setTargetSensorGroup($CCGame::MCV[2].target, $CCGame::MCV[2].team);

       case 3:
          $CCGame::MCV[3] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::GDI2MCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 3;
               team = 3;
          };
          WatchMCV($CCGame::MCV[3]);
          setTargetSensorGroup($CCGame::MCV[3].target, $CCGame::MCV[3].team);

       case 4:
          $CCGame::MCV[4] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::NOD2MCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 4;
               team = 4;
          };
          WatchMCV($CCGame::MCV[4]);
          setTargetSensorGroup($CCGame::MCV[4].target, $CCGame::MCV[4].team);

       case 5:
          $CCGame::MCV[5] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::REBMCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 5;
               team = 5;
          };
          WatchMCV($CCGame::MCV[5]);
          setTargetSensorGroup($CCGame::MCV[5].target, $CCGame::MCV[5].team);

       case 6:
          $CCGame::MCV[6] = new WheeledVehicle()
          {
               dataBlock  = "MCVVehicle";
	           position = $PosGrid::PhantomMCVSpawn[""@$CurrentMission@""];
               respawn    = "0";
               teamBought = 6;
               team = 6;
          };
          WatchMCV($CCGame::MCV[6]);
          setTargetSensorGroup($CCGame::MCV[6].target, $CCGame::MCV[6].team);

    }
    
    schedule(300000,0,"InitialWave",$CurrentMission);
}

function CnCSurvGame::leaveMissionArea(%game, %playerData, %player)
{
   if(%player.getState() $= "Dead")
      return;

   %player.client.outOfBounds = true;
   %player.OutsideKill = schedule(7500,0,"KillOutside", %player);
   messageClient(%player.client, 'LeaveMissionArea', '\c1Get Back In The Action Soldier!!! Deserters WILL BE KILLED.~wfx/misc/warning_beep.wav');

   if(%player.isPilotingMCV == 1) {

      echo("C&C: MCV Left Mission Area, Moving To Spawn");

      %obj = $CCGame::MCV[%player.client.team];

      if(%obj.deploySchedule) {
         %obj.deploySchedule.clear();
         %obj.deploySchedule = "";
      }

      if(%obj.deployed !$= "" && %obj.deployed == 1) {
         %obj.setThreadDir($DeployThread, false);
         %obj.playThread($DeployThread,"deploy");
         %obj.playAudio($DeploySound, MobileBaseUndeploySound);

         %obj.shield.open();
         %obj.shield.schedule(1000,"delete");
         %obj.deploySchedule = "";

         %obj.fullyDeployed = 0;
         %obj.noEnemyControl = 0;
      }
      %obj.deployed = 0;

      schedule(1100,0,"DoMCVTeleport",%obj);

      messageClient(%player.client, 'LeaveMissionArea', '\c1MCV outside the mission area, Moving to original spawn.~wfx/misc/warning_beep.wav');
   }
}

function CnCSurvGame::enterMissionArea(%game, %playerData, %player)
{
   if(%player.getState() $= "Dead")
      return;

   cancel(%player.OutsideKill);
   %player.client.outOfBounds = false;
   messageClient(%player.client, 'EnterMissionArea', '\c1You are back in the mission area.');
}


/////////////////////////
/////////////////////////
//SURVIVAL AI          //
//Credit To Dondlium_x //
//For Original Tank AI //
/////////////////////////
/////////////////////////
function SpawnSurvivalTanks(%mission, %wave) {
   switch(%wave) {
      case 1:
         for(%i = 0; %i < 5; %i++){
            %pt = getRandom(1,$PosSurvGrid::TankSpawnPtCt[%mission]);
            %final = vectorAdd($PosSurvGrid::TankSpawnPt[%mission, %pt], GetRandomPosition(50,1));
            SpawnTankAI(%final, 3, "Humvee");
         }
         for(%i = 0; %i < 10; %i++){
            %pt = getRandom(1,$PosSurvGrid::TankSpawnPtCt[%mission]);
            %final = vectorAdd($PosSurvGrid::TankSpawnPt[%mission, %pt], GetRandomPosition(50,1));
            SpawnTankAI(%final, 3, "MedTank");
         }
      case 2:
         for(%i = 0; %i < 10; %i++){
            %pt = getRandom(1,$PosSurvGrid::TankSpawnPtCt[%mission]);
            %final = vectorAdd($PosSurvGrid::TankSpawnPt[%mission, %pt], GetRandomPosition(50,1));
            SpawnTankAI(%final, 3, "Humvee");
         }
         for(%i = 0; %i < 15; %i++){
            %pt = getRandom(1,$PosSurvGrid::TankSpawnPtCt[%mission]);
            %final = vectorAdd($PosSurvGrid::TankSpawnPt[%mission, %pt], GetRandomPosition(50,1));
            SpawnTankAI(%final, 3, "MedTank");
         }
         for(%i = 0; %i < 5; %i++){
            %pt = getRandom(1,$PosSurvGrid::TankSpawnPtCt[%mission]);
            %final = vectorAdd($PosSurvGrid::TankSpawnPt[%mission, %pt], GetRandomPosition(50,1));
            SpawnTankAI(%final, 3, "MammothTank");
         }
      case 3:
         for(%i = 0; %i < 10; %i++){
            %pt = getRandom(1,$PosSurvGrid::TankSpawnPtCt[%mission]);
            %final = vectorAdd($PosSurvGrid::TankSpawnPt[%mission, %pt], GetRandomPosition(50,1));
            SpawnTankAI(%final, 3, "Humvee");
         }
         for(%i = 0; %i < 10; %i++){
            %pt = getRandom(1,$PosSurvGrid::TankSpawnPtCt[%mission]);
            %final = vectorAdd($PosSurvGrid::TankSpawnPt[%mission, %pt], GetRandomPosition(50,1));
            SpawnTankAI(%final, 3, "MedTank");
         }
         for(%i = 0; %i < 10; %i++){
            %pt = getRandom(1,$PosSurvGrid::TankSpawnPtCt[%mission]);
            %final = vectorAdd($PosSurvGrid::TankSpawnPt[%mission, %pt], GetRandomPosition(50,1));
            SpawnTankAI(%final, 3, "MammothTank");
         }
         for(%i = 0; %i < 5; %i++){
            %pt = getRandom(1,$PosSurvGrid::TankSpawnPtCt[%mission]);
            %final = vectorAdd($PosSurvGrid::TankSpawnPt[%mission, %pt], GetRandomPosition(50,1));
            SpawnTankAI(%final, 3, "StealthTank");
         }
      default:
         for(%i = 0; %i < 20; %i++){
            %pt = getRandom(1,$PosSurvGrid::TankSpawnPtCt[%mission]);
            %final = vectorAdd($PosSurvGrid::TankSpawnPt[%mission, %pt], GetRandomPosition(50,1));
            SpawnTankAI(%final, 3, "MedTank");
         }
   }
}

$DTank::ForwardForce = 7000;
$DTank::BackForce = 3000;
$DTank::TurnForce = 2500;


function SpawnTankAI(%pos,%team,%type){
   if(%team $= "")
	%team = 3;
   if(%pos $= "")
	%pos = "0 0 300";
   if(%type $= "") {
      %type = "MedTank";
   }

   if(%type $= "MedTank") {
      %drone = new HoverVehicle()
      {
         dataBlock    = MedTank;
         position     = %pos;
         rotation     = "0 0 1 0";
         team         = %team;
      };
      MissionCleanUp.add(%drone);
   }
   else if(%type $= "MammothTank") {
      %drone = new HoverVehicle()
      {
         dataBlock    = MammothTank;
         position     = %pos;
         rotation     = "0 0 1 0";
         team         = %team;
      };
      MissionCleanUp.add(%drone);
   }
   else if(%type $= "StealthTank") {
      %drone = new HoverVehicle()
      {
         dataBlock    = StealthTank;
         position     = %pos;
         rotation     = "0 0 1 0";
         team         = %team;
      };
      MissionCleanUp.add(%drone);
   }
   else if(%type $= "Humvee") {
      %drone = new HoverVehicle()
      {
         dataBlock    = Humvee;
         position     = %pos;
         rotation     = "0 0 1 0";
         team         = %team;
      };
      MissionCleanUp.add(%drone);
      %drone.isfast = 1;
   }

   setTargetSensorGroup(%drone.getTarget(), %team);

   %skill = 10;
   %drone.skill = 0.6 + (%skill / 25);

   schedule(100, 0, "DTankScanTargets",%drone);
}

function DTankScanTargets(%obj){
   if(!isObject(%obj))
	return;
   %pos = %obj.getposition();
   %closestClient = -1;
   %closestDistance = 32767;
   %scandist = 10000 * %obj.skill;
   %buildingtrgs = "";
   %groundtrgs = "";
   InitContainerRadiusSearch(%pos, %scanDist, ($TypeMasks::VehicleObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticShapeObjectType | $TypeMasks::TurretObjectType));
   while ((%searchResult = containerSearchNext()) != 0){
	%objtarget = firstWord(%searchResult);
	   if(isObject(%objtarget) && %objTarget !$= %obj && %objtarget.team != %obj.team){
	      %trgtype = %objtarget.getClassName();
	      if(%trgtype $= "StaticShape" || %trgtype $= "Turret" || %trgtype $= "HoverVehicle" || %trgtype $= "Player" || %trgtype $= "WheeledVehicle")
		   %groundtrgs = %groundtrgs SPC %objtarget;
       }
   }
   if(%groundtrgs){
	%target = firstWord(%groundtrgs);
	%groundtrgs = getWords(%groundtrgs,1,4);
	DTankGroundCombat(%obj, %target,%groundtrgs);
   }
   else{
	schedule(3000, 0, "DTankScanTargets", %obj);
   }
}

function DTankGroundCombat(%obj, %target, %Trglist){
   if(!isObject(%obj))
	return;
   if(!isObject(%target)){
          switch(%obj.getDatablock().getName()) {
             case "MedTank":
      	        %obj.setImageTrigger(3,false);
             case "MammothTank":
                switch(%obj.nextWeaponFire) {
                   case 2:
      	           %obj.setImageTrigger(2,false);
      	           %obj.setImageTrigger(3,false);
                   case 3:
      	           %obj.setImageTrigger(2,false);
      	           %obj.setImageTrigger(3,false);
                }
             case "StealthTank":
                %obj.setImageTrigger(3,false);
          }
	%obj.firing = "";
	if(%TrgList){
	   %target = firstWord(%Trglist);
	   %trglist = getWords(%trglist,1,4);
	}
	else{
	   DTankScanTargets(%obj);
	   return;
	}
   }
   %pos = %obj.getPosition();
   %tpos = %target.getPosition();
   %frdvec = vectorNormalize(getWords(%obj.getForwardVector(),0,1) SPC "0");
   %chkvec = vectorSub(%tpos,%pos);
   %chkvec = vectorNormalize(getWords(%chkvec,0,1) SPC "0");
   %turnvec = vectorsub(%chkvec,%frdvec);
   %vecdif = vectorlen(%turnvec);
   if(vectorDist(%pos,%tpos) > 2000){
	if(%obj.firing){
	   %obj.firing = "";
          switch(%obj.getDatablock().getName()) {
             case "MedTank":
      	        %obj.setImageTrigger(3,false);
             case "MammothTank":
                switch(%obj.nextWeaponFire) {
                   case 2:
      	           %obj.setImageTrigger(2,false);
      	           %obj.setImageTrigger(3,false);
                   case 3:
      	           %obj.setImageTrigger(2,false);
      	           %obj.setImageTrigger(3,false);
                }
             case "StealthTank":
                %obj.setImageTrigger(3,false);
          }
	}
	%target = "";
   }
   else if(vectorDist(%pos,%tpos) > 10){
	if(%vecdif >= "0.1"){
	   %vec = vectorCross(%turnvec, %frdvec);
	   %vec = vectorNormalize(vectorCross(%obj.getForwardVector(), %vec));
	   %Imppos = vectorAdd(%pos,%obj.getForwardVector());
	   %obj.applyImpulse(%Imppos,vectorScale(%vec,$DTank::TurnForce * %obj.skill));
	}
	if(!%obj.firing){
       //Tank Fire
          switch(%obj.getDatablock().getName()) {
             case "MedTank":
      	        %obj.setImageTrigger(3,true);
             case "MammothTank":
                switch(%obj.nextWeaponFire) {
                   case 2:
      	           %obj.setImageTrigger(2,false);
      	           %obj.setImageTrigger(3,true);
                   case 3:
      	           %obj.setImageTrigger(2,true);
      	           %obj.setImageTrigger(3,false);
                }
             case "StealthTank":
                %obj.setImageTrigger(3,true);
          }
   	   %obj.firing = 1;
	}
   }
   else{
	if(!%obj.firing){
       //Tank Fire
          switch(%obj.getDatablock().getName()) {
             case "MedTank":
      	        %obj.setImageTrigger(3,true);
             case "MammothTank":
                switch(%obj.nextWeaponFire) {
                   case 2:
      	           %obj.setImageTrigger(2,false);
      	           %obj.setImageTrigger(3,true);
                   case 3:
      	           %obj.setImageTrigger(2,true);
      	           %obj.setImageTrigger(3,false);
                }
             case "StealthTank":
                %obj.setImageTrigger(3,true);
          }
   	   %obj.firing = 1;
	}
	if(%vecdif < "1.2" || %vecdif >= "1.6"){
	   %Tvec1 = vectorNormalize(vectorcross(%chkvec,"0 0 1"));
	   %Tvec2 = vectorScale(%Tvec1,-1);
	   if(vectordist(%frdvec,%Tvec1) < vectorDist(%frdvec,%Tvec2))
		%tovec = vectorSub(%Tvec1,%frdvec);
	   else
		%tovec = vectorSub(%Tvec2,%frdvec);
	   %vec = vectorCross(%Tvec2, %frdvec);
	   %vec = vectorNormalize(vectorCross(%obj.getForwardVector(), %vec));
	   %Imppos = vectorAdd(%pos,%obj.getForwardVector());
	   %obj.applyImpulse(%Imppos,vectorScale(%vec,$DTank::TurnForce * %obj.skill));
	}
   }
   if(%obj.isfast) {
   %obj.applyImpulse(%pos,vectorScale(%obj.getForwardVector(),$DTank::ForwardForce / 3));
   }
   else {
   %obj.applyImpulse(%pos,vectorScale(%obj.getForwardVector(),$DTank::ForwardForce));
   }
   schedule(100, 0, "DTankGroundCombat",%obj,%target,%Trglist);
}
