datablock StaticShapeData(DeployedBPad) : StaticShapeDamageProfile {
	className = "BuildingPad"; //used in check too close
	shapeFile = "smiscf.dts";

	maxDamage      = 4;
	destroyedLevel = 4;
	disabledLevel  = 3.5;

	isShielded = false;
	energyPerDamagePoint = 30;
	maxEnergy = 200;
	rechargeRate = 0.25;

	explosion    = HandGrenadeExplosion;
	expDmgRadius = 3.0;
	expDamage    = 0.1;
	expImpulse   = 200.0;

	dynamicType = $TypeMasks::StaticShapeObjectType;
	deployedObject = true;
	cmdCategory = "DSupport";
	cmdIcon = CMDSensorIcon;
	cmdMiniIconName = "commander/MiniIcons/com_deploymotionsensor";
	targetNameTag = 'Building Construction Pad';
    targetTypeTag = '';
	deployAmbientThread = true;
	debrisShapeName = "debris_generic_small.dts";
	debris = DeployableDebris;
	heatSignature = 0;
	needsPower = true;
};

datablock ShapeBaseImageData(BuildPadDeployableImage) {
    mass = 1;
	emap = true;
	shapeFile = "stackable1s.dts";
	item = BuildPadDeployable;
	mountPoint = 1;
	offset = "0 0 0";
	deployed = DeployedBPad;
	heatSignature = 0;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";

	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateTransitionOnTriggerUp[1] = "Idle";

	isLarge = false;
	maxDepSlope = 360; // also see FloorDeployableImage::testSlopeTooGreat()
	deploySound = ItemPickupSound;

	minDeployDis = 0.1;
	maxDeployDis = 50.0;
};

datablock ItemData(BuildPadDeployable) {
	className = Pack;
	catagory = "Deployables";
	shapeFile = "stackable1s.dts";
    mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 1;
	rotate = true;
	image = "BuildPadDeployableImage";
	pickUpName = "a building pad";
	heatSignature = 0;
	emap = true;
};

function BuildPadDeployableImage::testSlopeTooGreat(%item) {
	if (%item.surface) {
	   return getTerrainAngle(%item.surfaceNrm) > %item.maxDepSlope;
	}
}

function BuildPadDeployableImage::testNoTerrainFound(%item) {
	// don't check this for non-Landspike turret deployables
}

function BuildPadDeployableImage::onPickup(%this, %obj, %shape, %amount) {
	// created to prevent console errors
}

function BuildPadDeployableImage::onDeploy(%item, %plyr, %slot) {
	//Object
	%className = "StaticShape";
 
    %client = %plyr.client;
    if($Building::TeamBuilding[%client.team]) {
       activateDeploySensorRed(%client);
       messageClient(%client, 'MsgDeployFailed', "Unable to comply, Building In Progress. ~wfx/misc/misc.error.wav");
       return;
    }
    //set the building
    //scale according to the building we deploy
    //Building Parameters
    // %deployed - Object Name, We Declare The Rest Below
    // %MsgBuild - Used By Score Menu, Messages, ect.
    // %scale - Scale of the building Pad (X, Y, Z)
    // %RadToScan - Radius To Scan For Other Buildings
    // %BuildTime - Time In Seconds To Complete Construction
    if($Building::HasAdvGuard[%client]) {
       //haha don't think I forgot about these..
       if($BuildingCount::PowerPlant[%client.team] <= 0) {
       activateDeploySensorRed(%client);
       messageclient(%client, 'MsgClient', '\c5Tech Error, Power Plant Required.');
       return;
       }
       if($BuildingCount::CommCenter[%client.team] <= 0) {
       activateDeploySensorRed(%client);
       messageclient(%client, 'MsgClient', '\c5Tech Error, Communications Center Required.');
       return;
       }
       if($BuildingCount::AdvGuardTurret[%client.team] > $TeamDeployableMax[AdvGuardTurretBasePack] - 1) {
       activateDeploySensorRed(%client);
       messageclient(%client, 'MsgClient', "\c5Error, The Team Has Already Deployed All Adv. Guard Towers. ~wfx/misc/misc.error.wav");
       return;
       }
       %deployed = "AdvGuard";
       %MsgBuild = "Advanced Guard Tower";
   	   %scale = "8 8 10";
       %RadToScan = 8;
       %BuildTime = $CNC::BuildTime[AdvGuardTower];
    }
    else if($Building::HasAdvPower[%client]) {
       if($BuildingCount::PowerPlant[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Power Plant Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::TiberiumRefinery[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Tiberium Refinery Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::AdvPowerPlant[%client.team] > $TeamDeployableMax[AdvPowerPlantDeployable] - 1) {
       activateDeploySensorRed(%client);
       messageclient(%client, 'MsgClient', "\c5Error, The Team Has Already Deployed All Adv. Power Plants. ~wfx/misc/misc.error.wav");
       return;
       }
       %deployed = "AdvPower";
       %MsgBuild = "Advanced Power Plant";
   	   %scale = "8 8 7";
       %RadToScan = 8;
       %BuildTime = $CNC::BuildTime[AdvPowerPlant];
    }
    else if($Building::HasBarracks[%client]) {
       if($BuildingCount::PowerPlant[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Power Plant Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::Barracks[%client.team] > $TeamDeployableMax[BarracksDeployable] - 1) {
       activateDeploySensorRed(%client);
       messageclient(%client, 'MsgClient', "\c5Error, The Team Has Already Deployed All Barracks. ~wfx/misc/misc.error.wav");
       return;
       }
       %deployed = "Barracks";
       if(%client.team == 1 || %client.team == 3)
          %MsgBuild = "Barracks";
       else if(%client.team == 2 || %client.team == 4)
          %MsgBuild = "Hand Of Nod";
       else if(%client.team == 5)
          %MsgBuild = "Rebel Armory";
       else if(%client.team == 6)
          %MsgBuild = "Phantom Embasy";
   	   %scale = "8 8 4";
       %RadToScan = 8;
       %BuildTime = $CNC::BuildTime[Barracks];
    }
    else if($Building::HasCommCenter[%client]) {
       if($BuildingCount::PowerPlant[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Power Plant Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::TiberiumRefinery[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Tiberium Refinery Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::CommCenter[%client.team] > $TeamDeployableMax[CommCenterDeployable] - 1) {
       activateDeploySensorRed(%client);
       messageclient(%client, 'MsgClient', "\c5Error, The Team Has Already Deployed All Communications Centers. ~wfx/misc/misc.error.wav");
       return;
       }
       %deployed = "CommCenter";
       %MsgBuild = "Communications Center";
   	   %scale = "10 10 20";
       %RadToScan = 10;
       %BuildTime = $CNC::BuildTime[CommCenter];
    }
    else if($Building::HasEnrich[%client]) {
       if($BuildingCount::PowerPlant[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Power Plant Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::CommCenter[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Communications Center Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($CNC::EnrichGenerator[%client.team] !$= "") {
       messageclient(%client, 'MsgClient', '\c5Similarity Error, Structure Already Exists.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::EnrichGenerator[%client.team] > $TeamDeployableMax[EnrichGeneratorDeployable] - 1) {
       activateDeploySensorRed(%client);
       messageclient(%client, 'MsgClient', "\c5Error, The Team Has Already Deployed All Enrich Generators. ~wfx/misc/misc.error.wav");
       return;
       }
       %deployed = "Enrich";
       %MsgBuild = "Enrich Generator";
   	   %scale = "25 25 20";
       %RadToScan = 25;
       %BuildTime = $CNC::BuildTime[EnrichGenerator];
    }
    else if($Building::HasAABat[%client]) {
       if($BuildingCount::PowerPlant[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Power Plant Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::AABattery[%client.team] > $TeamDeployableMax[AABatTurretBasePack] - 1) {
       activateDeploySensorRed(%client);
       messageclient(%client, 'MsgClient', "\c5Error, The Team Has Already Deployed All Anti-Air Batteries. ~wfx/misc/misc.error.wav");
       return;
       }
       %deployed = "AABatt";
       %MsgBuild = "AA Battery";
   	   %scale = "4 4 4";
       %RadToScan = 4;
       %BuildTime = $CNC::BuildTime[AABattery];
    }
    else if($Building::HasGuardTower[%client]) {
       if($BuildingCount::PowerPlant[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Power Plant Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::GuardTower[%client.team] > $TeamDeployableMax[GTowerTurretBasePack] - 1) {
       activateDeploySensorRed(%client);
       messageclient(%client, 'MsgClient', "\c5Error, The Team Has Already Deployed All Guard Towers. ~wfx/misc/misc.error.wav");
       return;
       }
       %deployed = "GuardTower";
       %MsgBuild = "Guard Tower";
   	   %scale = "4 4 4";
       %RadToScan = 4;
       %BuildTime = $CNC::BuildTime[GuardTower];
    }
    else if($Building::HasIonControl[%client]) {
       if($BuildingCount::PowerPlant[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Power Plant Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::CommCenter[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Communications Center Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($CNC::IonControl[%client.team] !$= "") {
       messageclient(%client, 'MsgClient', '\c5Similarity Error, Structure Already Exists.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::IonControl[%client.team] > $TeamDeployableMax[IonControlDeployable] - 1) {
       activateDeploySensorRed(%client);
       messageclient(%client, 'MsgClient', "\c5Error, The Team Has Already Deployed All Ion Cannon Controls. ~wfx/misc/misc.error.wav");
       return;
       }
       %deployed = "IonControl";
       %MsgBuild = "Ion Cannon Control";
   	   %scale = "25 25 20";
       %RadToScan = 25;
       %BuildTime = $CNC::BuildTime[IonControl];
    }
    else if($Building::HasGunTurret[%client]) {
       if($BuildingCount::PowerPlant[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Power Plant Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::GunTurret[%client.team] > $TeamDeployableMax[TurretBasePack] - 1) {
       activateDeploySensorRed(%client);
       messageclient(%client, 'MsgClient', "\c5Error, The Team Has Already Deployed All Gun Turrets. ~wfx/misc/misc.error.wav");
       return;
       }
       %deployed = "GunTurret";
       %MsgBuild = "Gun Turret";
   	   %scale = "4 4 4";
       %RadToScan = 4;
       %BuildTime = $CNC::BuildTime[GunTurret];
    }
    else if($Building::HasObelisk[%client]) {
       if($BuildingCount::PowerPlant[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Power Plant Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::CommCenter[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Communications Center Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::ObeliskTurret[%client.team] > $TeamDeployableMax[ObeliskTurretBasePack] - 1) {
       activateDeploySensorRed(%client);
       messageclient(%client, 'MsgClient', "\c5Error, The Team Has Already Deployed All Obelisks. ~wfx/misc/misc.error.wav");
       return;
       }
       %deployed = "Obelisk";
       %MsgBuild = "Obelisk Of Light";
   	   %scale = "8 8 10";
       %RadToScan = 8;
       %BuildTime = $CNC::BuildTime[Obelisk];
    }
    else if($Building::HasSAMSite[%client]) {
       if($BuildingCount::PowerPlant[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Power Plant Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::SAMTurret[%client.team] > $TeamDeployableMax[SAMTurretBasePack] - 1) {
       activateDeploySensorRed(%client);
       messageclient(%client, 'MsgClient', "\c5Error, The Team Has Already Deployed All SAM Sites. ~wfx/misc/misc.error.wav");
       return;
       }
       %deployed = "SAMSite";
       %MsgBuild = "SAM Site";
   	   %scale = "4 4 4";
       %RadToScan = 4;
       %BuildTime = $CNC::BuildTime[SAMSite];
    }
    else if($Building::HasNPALaser[%client]) {
       if($BuildingCount::PowerPlant[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Power Plant Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::NPAGunTurret[%client.team] > $TeamDeployableMax[NPATurretBasePack] - 1) {
       activateDeploySensorRed(%client);
       messageclient(%client, 'MsgClient', "\c5Error, The Team Has Already Deployed All Laser Batteries. ~wfx/misc/misc.error.wav");
       return;
       }
       %deployed = "LaserBatt";
       %MsgBuild = "Laser Battery";
   	   %scale = "4 4 4";
       %RadToScan = 4;
       %BuildTime = $CNC::BuildTime[NPAGunTurret];
    }
    else if($Building::HasNPAParticle[%client]) {
       if($BuildingCount::PowerPlant[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Power Plant Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::CommCenter[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Communications Center Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::PECTurret[%client.team] > $TeamDeployableMax[PECTurretBasePack] - 1) {
       activateDeploySensorRed(%client);
       messageclient(%client, 'MsgClient', "\c5Error, The Team Has Already Deployed All Particle Cannons. ~wfx/misc/misc.error.wav");
       return;
       }
       %deployed = "ParticleEC";
       %MsgBuild = "Particle Expulsion Cannon";
   	   %scale = "8 8 10";
       %RadToScan = 8;
       %BuildTime = $CNC::BuildTime[PEC];
    }
    else if($Building::HasPowerPlant[%client]) {
       if($BuildingCount::PowerPlant[%client.team] > $TeamDeployableMax[PowerPlantDeployable] - 1) {
       activateDeploySensorRed(%client);
       messageclient(%client, 'MsgClient', "\c5Error, The Team Has Already Deployed All Power Plants. ~wfx/misc/misc.error.wav");
       return;
       }
       %deployed = "PowerPlant";
       %MsgBuild = "Power Plant";
   	   %scale = "4 4 4"; //8 8 8
       %RadToScan = 4;   //8
       %BuildTime = $CNC::BuildTime[PowerPlant];
    }
    else if($Building::HasTempleOfNod[%client]) {
       if($BuildingCount::PowerPlant[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Power Plant Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::CommCenter[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Communications Center Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($CNC::TempleOfNOD[%client.team] !$= "") {
       messageclient(%client, 'MsgClient', '\c5Similarity Error, Structure Already Exists.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::TempOfNod[%client.team] > $TeamDeployableMax[TempOfNodDeployable] - 1) {
       activateDeploySensorRed(%client);
       messageclient(%client, 'MsgClient', "\c5Error, The Team Has Already Deployed All Temples Of NOD. ~wfx/misc/misc.error.wav");
       return;
       }
       %deployed = "TempleOfNod";
       %MsgBuild = "Temple Of Nod";
   	   %scale = "25 25 20";
       %RadToScan = 25;
       %BuildTime = $CNC::BuildTime[TempleOfNod];
    }
    else if($Building::HasTibRefinery[%client]) {
       if($BuildingCount::TiberiumRefinery[%client.team] > $TeamDeployableMax[TiberiumRefineryDeployable] - 1) {
       activateDeploySensorRed(%client);
       messageclient(%client, 'MsgClient', "\c5Error, The Team Has Already Deployed All Tiberium Refineries. ~wfx/misc/misc.error.wav");
       return;
       }
       %deployed = "Tiberium";
       %MsgBuild = "Tiberium Refinery";
   	   %scale = "15 15 20";
       %RadToScan = 15;
       %BuildTime = $CNC::BuildTime[TiberiumRefinery];
    }
    else if($Building::HasWarFact[%client]) {
       if($BuildingCount::PowerPlant[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Power Plant Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::TiberiumRefinery[%client.team] <= 0) {
       messageclient(%client, 'MsgClient', '\c5Tech Error, Tiberium Refinery Required.');
       activateDeploySensorRed(%client);
       return;
       }
       if($BuildingCount::WeaponsFactory[%client.team] > $TeamDeployableMax[WeaponsFactoryDeployable] - 1) {
       activateDeploySensorRed(%client);
       messageclient(%client, 'MsgClient', "\c5Error, The Team Has Already Deployed All War Factories. ~wfx/misc/misc.error.wav");
       return;
       }
       %deployed = "WarFact";
       %MsgBuild = "Weapons / War Factory";
   	   %scale = "15 15 4";
       %RadToScan = 15;
       %BuildTime = $CNC::BuildTime[WarFactory];
    }

	%grounded = 0;
	if (%item.surface.getClassName() $= TerrainBlock)
		%grounded = 1;

	%playerVector = vectorNormalize(-1 * getWord(%plyr.getEyeVector(),1) SPC getWord(%plyr.getEyeVector(),0) SPC "0");

	%rot = intRot("1 0 0 0",%playerVector);

	%scale = vectorMultiply(%scale,1/4 SPC 1/3 SPC 2);

    //Scan for other buildings
    %TargetSearchMask = $TypeMasks::StaticShapeObjectType | $TypeMasks::TurretObjectType;
    InitContainerRadiusSearch(%item.surfacePt,%RadToScan,%TargetSearchMask);
    while ((%Scanned = ContainerSearchNext()) != 0) {
       if(isObject(%Scanned)){
	      %trgtype = %Scanned.getClassName();
	      if(%trgtype $= "StaticShape" || %trgtype $= "Turret") {
             messageClient(%client, 'MsgDeployFailed', "Error: Deploy Location Overlaps A Nearby Building, Space Needed "@%RadToScan@"M. ~wfx/misc/misc.error.wav");
             return;
          }
       }
    }

	%deplObj = new (%className)() {
		dataBlock = %item.deployed;
		scale = %scale;
	};
 
    %deplObj.building = %MsgBuild;
    %deplObj.SetUpRotationism = %rot; //Eh, easy way..

//////////////////////////Apply settings//////////////////////////////

	// [[Location]]:

	// exact:
	%deplObj.setTransform(%item.surfacePt SPC %rot);

	// misc info
	addDSurface(%item.surface,%deplObj);

	// [[Settings]]:

	%deplObj.grounded = %grounded;
	%deplObj.needsFit = 1;

	// set team, owner, and handle
	%deplObj.team = %plyr.client.team;
	%deplObj.setOwner(%plyr);

	// set power frequency
	%deplObj.powerFreq = %plyr.powerFreq;

	// set the sensor group if it needs one
	if (%deplObj.getTarget() != -1)
		setTargetSensorGroup(%deplObj.getTarget(), %plyr.client.team);
  
    setTargetName(%deplObj.target,addTaggedString("Construction Materials Box"));
    
    %deplObj.OwnerClientGUID = %plyr.client.GUID;

	// place the deployable in the MissionCleanup/Deployables group (AI reasons)
	addToDeployGroup(%deplObj);

	//let the AI know as well...
	AIDeployObject(%plyr.client, %deplObj);

	// play the deploy sound
	serverPlay3D(%item.deploySound, %deplObj.getTransform());


	// take the deployable off the player's back and out of inventory
	%plyr.unmountImage(%slot);
	%plyr.decInventory(%item.item, 1);

	%deplObj.deploy();

      %count = ClientGroup.getCount();
      for(%i = 0; %i < %count; %i++) {
         %cl = ClientGroup.getObject(%i);
         if(%cl.team == %deplObj.team) {
            messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Started ("@%deplObj.building@").");
         }
      }
    //stops the team from building ANOTHER building during a process
    $Building::TeamBuilding[%client.team] = 1;
    //Alviss - For Future Reference - Call The Piecing Function Here
 
    //Complete the building
    schedule((%BuildTime * 1000),0,"ConstructionComplete", %client, %client.team, %deplObj, %deployed, %item);

	return %deplObj;
}

function DeployedBPad::onDestroyed(%this, %obj, %prevState) {
	if (%obj.isRemoved)
		return;
	%obj.isRemoved = true;
	Parent::onDestroyed(%this, %obj, %prevState);
	remDSurface(%obj);
	%obj.schedule(500, "delete");
    //note to alviss
    //put the cancel building process thingy here..
    //However be aware of the fact that the pad is destroyed
    //when the building process is completed (line 335).
}

function BuildPadDeployableImage::onMount(%data, %obj, %node) {
	%obj.hasFloor = true; // set for floorcheck
}

function BuildPadDeployableImage::onUnmount(%data, %obj, %node) {
	%obj.hasFloor = "";
}

function BuildResetMyTeam(%client, %goto) {
   echo(""@%client@" team reset to "@%goto@".");
   %client.team = %goto;
}

//This funciton completes the building process
function ConstructionComplete(%client, %team, %obj, %objToDeploy, %item) {
   $Building::TeamBuilding[%team] = 0; //reset this anyways
   if(!isObject(%obj)) {
      %count = ClientGroup.getCount();
      for(%i = 0; %i < %count; %i++) {
         %cl = ClientGroup.getObject(%i);
         if(%cl.team == %team) {
            messageclient(%cl, 'MsgClient', "\c5Base Update: Building Lost During Construction.");
         }
      }
      return;
   }
   //Check for the client.
      if(!%client) {
         %count = ClientGroup.getCount();
         for(%i = 0; %i < %count; %i++) {
            %cl = ClientGroup.getObject(%i);
            if(%cl.team == %team) {
               messageclient(%cl, 'MsgClient', "\c5Base Update: Builder Left The Game, Process Canceled.");
            }
         }
         return;
      }
   //
   //ACK!! No Evil Buildings In My Base!!!
   // Means: Did he change his team before the building completed?
   if(%client.team != %team) {
      echo(""@%client@" changed team, temporarily setting it back");
      %client.curTeam = %client.team;
      %client.team = %team;
      schedule(3000,0,"BuildResetMyTeam", %client, %client.curTeam);
   }
   //and now the Long and Boring code.
   //T3h Oh Ehm Gee
   if(%objToDeploy $= "AdvGuard") {
	     %deplObj = new (Turret)() {
		    dataBlock = AdvGuardTurretDeployedBase;
            scale = "1 1 1";
            deployed = true;
         };
         %deplObj.mountImage("ADVGuardBarrelLarge", 0);

         addDSurface(%item.surface,%deplObj);
         addToDeployGroup(%deplObj);
         %deplObj.team = %team;

	     if (%deplObj.getTarget() != -1)
		    setTargetSensorGroup(%deplObj.getTarget(), %client.team);

         %deplObj.getDataBlock().onGainPowerEnabled(%deplObj);
         %deplObj.getDataBlock().GainPower(%deplObj);
         %deplObj.powerCount = 1;

         //CG Turret
         %turret = new (Turret)() {
		    dataBlock = AdvGuardTowerCGBase;
            scale = "0.5 0.5 0.5";
		    deployed = true;
	     };
         MissionCleanup.add(%turret);
         %turret.team = %deplObj.team;
         %turret.setSelfPowered();
         %turret.getDataBlock().onGainPowerEnabled(%turret);
         %turret.getDataBlock().GainPower(%turret);
         %turret.powerCount = 1;
         %deplObj.mountObject(%turret, 10);
         %turret.setCapacitorRechargeRate(999);
         %turret.mountobj = %deplObj;
         %deplObj.turretObject = %turret;
         %turret.team = %deplObj.team;
         %turret.base = %deplObj;
         setTargetSensorGroup(%turret.getTarget(),%turret.team);
         %turret.mountImage("GuardBarrelLarge", 0);
         %turret.setAutoFire(true); //YES

         %count = ClientGroup.getCount();
         for(%i = 0; %i < %count; %i++) {
            %cl = ClientGroup.getObject(%i);
            if(%cl.team == %deplObj.team) {
               messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, Adv. Guard Tower.");
            }
         }

         $Power[%deplObj.team] = $Power[%deplObj.team] - 150;
         CheckPowerLowLevel(%deplObj.team);
         $BuildingCount::AdvGuardTurret[%deplObj.team]++;
         $TeamDeployedCount[%deplObj.team,AdvGuardTurretBasePack]++;
         echo("C&C: Team "@%deplObj.team@" Built an Adv. Guard Tower at "@%deplObj.getPosition()@".");
      }
      ////////////////////
      else if(%objToDeploy $= "AdvPower") {
	     %deplObj = new (StaticShape)() {
		    dataBlock = DeployedAdvPowerPlant;
            scale = "2.5 2.5 2.5";
		    deployed = true;
	     };
      
	     // set team, owner, and handle
      %deplObj.team = %team;
      
	     setTargetName(%deplObj.target,addTaggedString("Adv. Power Plant"));

	     // set power
	     %deplObj.setSelfPowered();

	     // set the sensor group if it needs one
	     if (%deplObj.getTarget() != -1)
		    setTargetSensorGroup(%deplObj.getTarget(), %client.team);

	     // place the deployable in the MissionCleanup/Deployables group (AI reasons)
	     addToDeployGroup(%deplObj);

	     //let the AI know as well...
	     AIDeployObject(%client, %deplObj);

	     // play the deploy sound
	     serverPlay3D(%item.deploySound, %deplObj.getTransform());

	     addDSurface(%item.surface,%deplObj);

	     %deplObj.playThread($PowerThread,"Power");

         $BuildingCount::AdvPowerPlant[%deplObj.team]++;
         $Power[%deplObj.team] = $Power[%deplObj.team] + 500; //Add 500 Power From The Team Count
         %deplObj.team.AdvPowerPlantCount++;
         $TeamDeployedCount[%deplObj.team,AdvPowerPlantDeployable]++;

         %count = ClientGroup.getCount();
            for(%i = 0; %i < %count; %i++) {
               %cl = ClientGroup.getObject(%i);
               if(%cl.team == %deplObj.team) {
                  messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, Advanced Power Plant.");
               }
            }
         CheckPowerGoodLevel(%deplObj.team);
         echo("C&C: Team "@%deplObj.team@" Built an Adv. Power Plant at "@%deplObj.getPosition()@".");
      }
      //////////////
      else if(%objToDeploy $= "Barracks") {
         %deplObj = new (StaticShape)() {
            dataBlock = DeployedBarracks;
            deployed = true;
         };
         %deplObj.team = %team;
         %deplObj.team.BarracksCount++;

         if(%deplObj.team == 1 || %deplObj.team == 3) {
	        setTargetName(%deplObj.target,addTaggedString("Barracks"));
         }
         else if(%deplObj.team == 6) {
	        setTargetName(%deplObj.target,addTaggedString("Phantom Embassy"));
         }
         else {
	        setTargetName(%deplObj.target,addTaggedString("Hand Of NOD"));
         }
         $BuildingCount::Barracks[%deplObj.team]++;
         $TeamDeployedCount[%deplObj.team,BarracksDeployable]++;
         %deplObj.counter = $BuildingCount::Barracks[%deplObj.team];
         $CNC::BarracksBuilding[%deplObj.team,%deplObj.counter] = %deplObj;

         addDSurface(%item.surface,%deplObj);

         if(%deplObj.getTarget() != -1)
            setTargetSensorGroup(%deplObj.getTarget(), %client.team);

         addToDeployGroup(%deplObj);

         AIDeployObject(%client, %deplObj);

         // play the deploy sound
         serverPlay3D(%item.deploySound, %deplObj.getTransform());

         %deplObj.deploy();

         // Adjust the trigger object
         adjustTrigger(%deplObj);

         %count = ClientGroup.getCount();
         for(%i = 0; %i < %count; %i++) {
            %cl = ClientGroup.getObject(%i);
            if(%cl.team == %deplObj.team) {
               if(%deplObj.team == 1 || %deplObj.team == 3)
               messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, Barracks.");
               else if(%deplObj.team == 6)
               messageclient(%cl, 'MsgClient', "\c5Base Update: Building Ready: Phantom Embassy.");
               else
               messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, Hand Of Nod.");
            }
         }

         echo("C&C: Team "@%deplObj.team@" Built a Barracks/Hand Of NOD at "@%deplObj.getPosition()@".");
      }
      //////////////
      else if(%objToDeploy $= "CommCenter") {
	     %deplObj = new (StaticShape)() {
		    dataBlock = DeployedCommCenter;
            scale = "2.5 2.5 2.5";
		    deployed = true;
	     };

	     // set team, owner, and handle
      %deplObj.team = %team;

	     setTargetName(%deplObj.target,addTaggedString("Communications Center"));

	     // set power
	     %deplObj.setSelfPowered();

	     // set the sensor group if it needs one
	     if (%deplObj.getTarget() != -1)
		    setTargetSensorGroup(%deplObj.getTarget(), %client.team);

	     // place the deployable in the MissionCleanup/Deployables group (AI reasons)
	     addToDeployGroup(%deplObj);

	     //let the AI know as well...
	     AIDeployObject(%client, %deplObj);

	     // play the deploy sound
	     serverPlay3D(%item.deploySound, %deplObj.getTransform());

	     addDSurface(%item.surface,%deplObj);

	     %deplObj.playThread($PowerThread,"Power");

         $TeamDeployedCount[%deplObj.team,CommCenterDeployable]++;
         $BuildingCount::CommCenter[%deplObj.team]++;
         $Power[%deplObj.team] = $Power[%deplObj.team] - 150; //Add 500 Power From The Team Count
         CheckPowerLowLevel(%deplObj.team);
         %deplObj.team.CommCenterCount++;

         %count = ClientGroup.getCount();
         for(%i = 0; %i < %count; %i++) {
            %cl = ClientGroup.getObject(%i);
            if(%cl.team == %deplObj.team) {
               messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, Communications Center.");
               if(%deplObj.team == 1 || %deplObj.team == 3)
                  messageclient(%cl, 'MsgClient', "\c5Superweapon Update: Airstrike Charging.");
            }
         }
         if($BuildingCount::CommCenter[%deplObj.team] == 1) { //who has the last laugh now huh?
         //this ensures that there is only 1 Airstrike availible
            if(%deplObj.team == 1 || %deplObj.team == 3) {
               $Superweapon::AirstrikeReady[%deplObj.team] = 0;
               $SuperweaponTimer::Airstrike[%deplObj.team] = 120;
               schedule(1000,0,"DoAirTimer", %deplObj.team);
            }
         }
         echo("C&C: Team "@%deplObj.team@" Built a Comm. Center at "@%deplObj.getPosition()@".");
      }
      //////////////
      else if(%objToDeploy $= "Enrich") {
	     %deplObj = new (StaticShape)() {
		    dataBlock = DeployedEnrichGenerator;
            scale = "10 10 10";
		    deployed = true;
         };
         // set team, owner, and handle
         %deplObj.team = %team;

         // set power
	     %deplObj.setSelfPowered();

	     // set the sensor group if it needs one
	     if (%deplObj.getTarget() != -1)
		    setTargetSensorGroup(%deplObj.getTarget(), %client.team);

	     // place the deployable in the MissionCleanup/Deployables group (AI reasons)
	     addToDeployGroup(%deplObj);

	     //let the AI know as well...
	     AIDeployObject(%client, %deplObj);

	     // play the deploy sound
	     serverPlay3D(%item.deploySound, %deplObj.getTransform());

	     // increment the team count for this deployed object
	     $TeamDeployedCount[%client.team, EnrichGeneratorDeployable]++;

	     addDSurface(%item.surface,%deplObj);

	     %deplObj.playThread($PowerThread,"Power");

         $BuildingCount::EnrichGenerator[%deplObj.team]++;
         $Power[%deplObj.team] = $Power[%deplObj.team] - 250; //Add 250 Power From The Team Count
         %deplObj.team.EnrichGeneratorCount++;
    
         %count = ClientGroup.getCount();
         for(%i = 0; %i < %count; %i++) {
            %cl = ClientGroup.getObject(%i);
            if(%cl.team == %deplObj.team) {
               messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, Enrich Generator.");
               messageclient(%cl, 'MsgClient', "\c5Superweapon Update: Spacious Rift Charging.");
            }
            else {
               messageclient(%cl, 'MsgClient', "\c5Superweapon Update: WARNING: Enrich Generator Detected.");
            }
         }
         CheckPowerLowLevel(%deplObj.team);
         $CNC::EnrichGenerator[%deplObj.team] = %deplObj;   //one per team
         %deplObj.canFireRift = 0;
         %deplObj.RiftSched = schedule(600000,0,"RiftReady",%deplObj);
         $SuperweaponTimer::Rift[%deplObj.team] = 600;
         schedule(1000,0,"DoRiftTimer", %deplObj);
         echo("C&C: Team "@%deplObj.team@" Built an Enrich Generator at "@%deplObj.getPosition()@".");
      }
      //////////////
      else if(%objToDeploy $= "AABatt") {
	     %deplObj = new (Turret)() {
		    dataBlock = AABatTurretDeployedBase;
            scale = "1 1 1";
            deployed = true;
         };
         %deplObj.mountImage("AABarrelLarge", 0);

         addDSurface(%item.surface,%deplObj);
         addToDeployGroup(%deplObj);
         %deplObj.team = %team;

	     if (%deplObj.getTarget() != -1)
		    setTargetSensorGroup(%deplObj.getTarget(), %client.team);

         %deplObj.getDataBlock().onGainPowerEnabled(%deplObj);
         %deplObj.getDataBlock().GainPower(%deplObj);
         %deplObj.powerCount = 1;

         %count = ClientGroup.getCount();
         for(%i = 0; %i < %count; %i++) {
            %cl = ClientGroup.getObject(%i);
            if(%cl.team == %deplObj.team) {
               messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, AA Battery.");
            }
         }

         $TeamDeployedCount[%deplObj.team, AABatTurretBasePack]++;
         $Power[%deplObj.team] = $Power[%deplObj.team] - 100;
         CheckPowerLowLevel(%deplObj.team);
         $BuildingCount::AABattery[%deplObj.team]++;
         echo("C&C: Team "@%deplObj.team@" Built an AA Battery at "@%deplObj.getPosition()@".");
      }
      //////////////
      else if(%objToDeploy $= "GuardTower") {
	     %deplObj = new (Turret)() {
		    dataBlock = GTowerTurretDeployedBase;
            scale = "1 1 1";
            deployed = true;
         };
         %deplObj.mountImage("GuardBarrelLarge", 0);

         addDSurface(%item.surface,%deplObj);
         addToDeployGroup(%deplObj);
         %deplObj.team = %team;

	     if (%deplObj.getTarget() != -1)
		    setTargetSensorGroup(%deplObj.getTarget(), %client.team);

         %deplObj.getDataBlock().onGainPowerEnabled(%deplObj);
         %deplObj.getDataBlock().GainPower(%deplObj);
         %deplObj.powerCount = 1;

         %count = ClientGroup.getCount();
         for(%i = 0; %i < %count; %i++) {
            %cl = ClientGroup.getObject(%i);
            if(%cl.team == %deplObj.team) {
               messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, Guard Tower.");
            }
         }

         $TeamDeployedCount[%deplObj.team,GTowerTurretBasePack]++;
         $Power[%deplObj.team] = $Power[%deplObj.team] - 50;
         CheckPowerLowLevel(%deplObj.team);
         $BuildingCount::GuardTower[%deplObj.team]++;
         echo("C&C: Team "@%deplObj.team@" Built a Guard Tower at "@%deplObj.getPosition()@".");
      }
      //////////////
      else if(%objToDeploy $= "IonControl") {
         %deplObj = new (StaticShape)() {
		    dataBlock = DeployedIonControl;
            scale = "10 10 10";
		    deployed = true;
	     };

	     // set team, owner, and handle
      %deplObj.team = %team;

	     // set power
	     %deplObj.setSelfPowered();

	     // set the sensor group if it needs one
	     if (%deplObj.getTarget() != -1)
		    setTargetSensorGroup(%deplObj.getTarget(), %client.team);

	     // place the deployable in the MissionCleanup/Deployables group (AI reasons)
	     addToDeployGroup(%deplObj);

	     //let the AI know as well...
	     AIDeployObject(%client, %deplObj);

	     // play the deploy sound
	     serverPlay3D(%item.deploySound, %deplObj.getTransform());

	     // increment the team count for this deployed object
         $TeamDeployedCount[%deplObj.team,IonControlDeployable]++;

	     addDSurface(%item.surface,%deplObj);

	     %deplObj.playThread($PowerThread,"Power");

         $BuildingCount::IonControl[%deplObj.team]++;
         $Power[%deplObj.team] = $Power[%deplObj.team] - 250; //Add 250 Power From The Team Count
         %deplObj.team.IonControlCount++;

         %count = ClientGroup.getCount();
         for(%i = 0; %i < %count; %i++) {
            %cl = ClientGroup.getObject(%i);
               if(%cl.team == %deplObj.team) {
                  messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, Ion Cannon Control.");
                  messageclient(%cl, 'MsgClient', "\c5Superweapon Update: Ion Cannon Charging.");
               }
               else {
                  messageclient(%cl, 'MsgClient', "\c5Superweapon Update: WARNING: Ion Cannon Control Detected.");
               }
         }
         CheckPowerLowLevel(%deplObj.team);
         $CNC::IonControl[%deplObj.team] = %deplObj;   //one per team
         %deplObj.canFireIonCannon = 0;
         %deplObj.IonCannonSched = schedule(240000,0,"IonCannonReady",%deplObj);
         $SuperweaponTimer::IonCannon[%deplObj.team] = 240;
         schedule(1000,0,"DoIonTimer", %deplObj);
         echo("C&C: Team "@%deplObj.team@" Built an Ion Control at "@%deplObj.getPosition()@".");
      }
      //////////////
      else if(%objToDeploy $= "GunTurret") {
	     %deplObj = new (Turret)() {
		    dataBlock = GunTurretDeployedBase;
            scale = "1 1 1";
            deployed = true;
         };
         %deplObj.mountImage("PlasmaBarrelLarge", 0);

         addDSurface(%item.surface,%deplObj);
         addToDeployGroup(%deplObj);
         %deplObj.team = %team;

	     if (%deplObj.getTarget() != -1)
		    setTargetSensorGroup(%deplObj.getTarget(), %client.team);

         %deplObj.getDataBlock().onGainPowerEnabled(%deplObj);
         %deplObj.getDataBlock().GainPower(%deplObj);
         %deplObj.powerCount = 1;

         %count = ClientGroup.getCount();
         for(%i = 0; %i < %count; %i++) {
            %cl = ClientGroup.getObject(%i);
            if(%cl.team == %deplObj.team) {
               messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, Gun Turret.");
            }
         }

         $TeamDeployedCount[%deplObj.team,TurretBasePack]++;
         $Power[%deplObj.team] = $Power[%deplObj.team] - 50;
         CheckPowerLowLevel(%deplObj.team);
         $BuildingCount::GunTurret[%deplObj.team]++;
         echo("C&C: Team "@%deplObj.team@" Built a Gun turret at "@%deplObj.getPosition()@".");
      }
      //////////////
      else if(%objToDeploy $= "Obelisk") {
	     %deplObj = new (Turret)() {
		    dataBlock = ObeliskTurretDeployedBase;
            scale = "1 1 1";
            deployed = true;
         };
         %deplObj.mountImage("ObeliskBarrelLarge", 0);

         addDSurface(%item.surface,%deplObj);
         addToDeployGroup(%deplObj);
         %deplObj.team = %team;

	     if (%deplObj.getTarget() != -1)
		    setTargetSensorGroup(%deplObj.getTarget(), %client.team);

         %deplObj.getDataBlock().onGainPowerEnabled(%deplObj);
         %deplObj.getDataBlock().GainPower(%deplObj);
         %deplObj.powerCount = 1;
         
         %count = ClientGroup.getCount();
         for(%i = 0; %i < %count; %i++) {
            %cl = ClientGroup.getObject(%i);
            if(%cl.team == %deplObj.team) {
               messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, Obelisk Of Light.");
            }
         }

         $TeamDeployedCount[%deplObj.team,ObeliskTurretBasePack]++;
         $Power[%deplObj.team] = $Power[%deplObj.team] - 150;
         CheckPowerLowLevel(%deplObj.team);
         $BuildingCount::ObeliskTurret[%deplObj.team]++;
         echo("C&C: Team "@%deplObj.team@" Built an Obelisk at "@%deplObj.getPosition()@".");
      }
      //////////////
      else if(%objToDeploy $= "SAMSite") {
	     %deplObj = new (Turret)() {
		    dataBlock = SAMTurretDeployedBase;
            scale = "1 1 1";
            deployed = true;
         };
         %deplObj.mountImage("MissileBarrelLarge", 0);

         addDSurface(%item.surface,%deplObj);
         addToDeployGroup(%deplObj);
         %deplObj.team = %team;

	     if (%deplObj.getTarget() != -1)
		    setTargetSensorGroup(%deplObj.getTarget(), %client.team);

         %deplObj.getDataBlock().onGainPowerEnabled(%deplObj);
         %deplObj.getDataBlock().GainPower(%deplObj);
         %deplObj.powerCount = 1;
         
         %count = ClientGroup.getCount();
         for(%i = 0; %i < %count; %i++) {
            %cl = ClientGroup.getObject(%i);
            if(%cl.team == %deplObj.team) {
               messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, SAM Site.");
            }
         }

         $TeamDeployedCount[%deplObj.team,SAMTurretBasePack]++;
         $Power[%deplObj.team] = $Power[%deplObj.team] - 50;
         CheckPowerLowLevel(%deplObj.team);
         $BuildingCount::SAMTurret[%deplObj.team]++;
         echo("C&C: Team "@%deplObj.team@" Built a SAM Site at "@%deplObj.getPosition()@".");
      }
      //////////////
      else if(%objToDeploy $= "LaserBatt") {
	     %deplObj = new (Turret)() {
		    dataBlock = NPAGunTurretDeployedBase;
            scale = "1 1 1";
            deployed = true;
         };
         %deplObj.mountImage("LaserBarrelLarge", 0);

         addDSurface(%item.surface,%deplObj);
         addToDeployGroup(%deplObj);
         %deplObj.team = %team;

	     if (%deplObj.getTarget() != -1)
		    setTargetSensorGroup(%deplObj.getTarget(), %client.team);

         %deplObj.getDataBlock().onGainPowerEnabled(%deplObj);
         %deplObj.getDataBlock().GainPower(%deplObj);
         %deplObj.powerCount = 1;
         
         %count = ClientGroup.getCount();
         for(%i = 0; %i < %count; %i++) {
            %cl = ClientGroup.getObject(%i);
            if(%cl.team == %deplObj.team) {
               messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, Laser Battery.");
            }
         }

         $TeamDeployedCount[%deplObj.team,NPATurretBasePack]++;
         $Power[%deplObj.team] = $Power[%deplObj.team] - 50;
         CheckPowerLowLevel(%deplObj.team);
         $BuildingCount::NPAGunTurret[%deplObj.team]++;
         echo("C&C: Team "@%deplObj.team@" Built a Laser Battery at "@%deplObj.getPosition()@".");
      }
      //////////////
      else if(%objToDeploy $= "ParticleEC") {
	     %deplObj = new (Turret)() {
		    dataBlock = PECTurretDeployedBase;
            scale = "1 1 1";
            deployed = true;
         };
         %deplObj.mountImage("ELFBarrelLarge", 0);

         addDSurface(%item.surface,%deplObj);
         addToDeployGroup(%deplObj);
         %deplObj.team = %team;

	     if (%deplObj.getTarget() != -1)
		    setTargetSensorGroup(%deplObj.getTarget(), %client.team);

         %deplObj.getDataBlock().onGainPowerEnabled(%deplObj);
         %deplObj.getDataBlock().GainPower(%deplObj);
         %deplObj.powerCount = 1;

         %count = ClientGroup.getCount();
         for(%i = 0; %i < %count; %i++) {
            %cl = ClientGroup.getObject(%i);
            if(%cl.team == %deplObj.team) {
               messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, Particle Expulsion Cannon.");
            }
         }

         $TeamDeployedCount[%deplObj.team,PECTurretBasePack]++;
         $Power[%deplObj.team] = $Power[%deplObj.team] - 150;
         CheckPowerLowLevel(%deplObj.team);
         $BuildingCount::PECTurret[%deplObj.team]++;
         echo("C&C: Team "@%deplObj.team@" Built a P.E.C. at "@%deplObj.getPosition()@".");
      }
      //////////////
      else if(%objToDeploy $= "PowerPlant") {
	     %deplObj = new (StaticShape)() {
		    dataBlock = DeployedPowerPlant;
		    deployed = true;
	     };

	     // set team, owner, and handle
      %deplObj.team = %team;

	     setTargetName(%deplObj.target,addTaggedString("Power Plant"));

	     // set power
	     %deplObj.setSelfPowered();

	     // set the sensor group if it needs one
	     if (%deplObj.getTarget() != -1)
		    setTargetSensorGroup(%deplObj.getTarget(), %client.team);

	     // place the deployable in the MissionCleanup/Deployables group (AI reasons)
	     addToDeployGroup(%deplObj);

	     //let the AI know as well...
	     AIDeployObject(%client, %deplObj);

	     // play the deploy sound
	     serverPlay3D(%item.deploySound, %deplObj.getTransform());

	     // increment the team count for this deployed object
	     $TeamDeployedCount[%deplObj.team, PowerPlantDeployable]++;

	     addDSurface(%item.surface,%deplObj);

	     %deplObj.playThread($PowerThread,"Power");

         $BuildingCount::PowerPlant[%deplObj.team]++;
         $Power[%deplObj.team] = $Power[%deplObj.team] + 250; //Add 250 Power From The Team Count
         %deplObj.team.PowerPlantCount++;

         %count = ClientGroup.getCount();
         for(%i = 0; %i < %count; %i++) {
            %cl = ClientGroup.getObject(%i);
            if(%cl.team == %deplObj.team) {
               messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, Power Plant.");
            }
         }
         CheckPowerGoodLevel(%deplObj.team);
         echo("C&C: Team "@%deplObj.team@" Built a Power Plant at "@%deplObj.getPosition()@".");
      }
      //////////////
      else if(%objToDeploy $= "TempleOfNod") {
	     %deplObj = new (StaticShape)() {
	 	    dataBlock = DeployedTempOfNod;
            scale = "10 10 10";
		    deployed = true;
	     };

	     // set team, owner, and handle
      %deplObj.team = %team;

	     // set power
	     %deplObj.setSelfPowered();

	     // set the sensor group if it needs one
	     if (%deplObj.getTarget() != -1)
		    setTargetSensorGroup(%deplObj.getTarget(), %client.team);

	     // place the deployable in the MissionCleanup/Deployables group (AI reasons)
	     addToDeployGroup(%deplObj);

	     //let the AI know as well...
	     AIDeployObject(%client, %deplObj);

	     // play the deploy sound
	     serverPlay3D(%item.deploySound, %deplObj.getTransform());

	     // increment the team count for this deployed object
	     $TeamDeployedCount[%deplObj.team, TempOfNodDeployable]++;

	     addDSurface(%item.surface,%deplObj);

	     %deplObj.playThread($PowerThread,"Power");

         $BuildingCount::TempOfNod[%deplObj.team]++;
         $Power[%deplObj.team] = $Power[%deplObj.team] - 250; //Add 250 Power From The Team Count
         %deplObj.team.TempOfNodCount++;

         %count = ClientGroup.getCount();
         for(%i = 0; %i < %count; %i++) {
            %cl = ClientGroup.getObject(%i);
            if(%cl.team == %deplObj.team) {
               messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, Temple Of NOD.");
               messageclient(%cl, 'MsgClient', "\c5Superweapon Update: Nuclear Missile Charging.");
            }
            else {
               messageclient(%cl, 'MsgClient', "\c5Superweapon Update: WARNING: Temple Of NOD Detected.");
            }
         }
         CheckPowerLowLevel(%deplObj.team);
         $CNC::TempleOfNOD[%deplObj.team] = %deplObj;   //one per team
         %deplObj.canFireNuke = 0;
         %deplObj.NukeSched = schedule(360000,0,"NukeReady",%deplObj);
         $SuperweaponTimer::Nuke[%deplObj.team] = 360;
         schedule(1000,0,"DoNukeTimer", %deplObj);
         echo("C&C: Team "@%deplObj.team@" Built a Temple Of NOD at "@%deplObj.getPosition()@".");
      }
      //////////////
      else if(%objToDeploy $= "Tiberium") {
	     %deplObj = new (StaticShape)() {
            dataBlock = DeployedTiberiumRefinery;
            scale = "4.5 4.5 4.5";
            deployed = true;
         };
         // set team, owner, and handle
      %deplObj.team = %team;

	     setTargetName(%deplObj.target,addTaggedString("Tiberium Refinery"));

	     // set power
	     %deplObj.setSelfPowered();

	     // set the sensor group if it needs one
	     if (%deplObj.getTarget() != -1)
		    setTargetSensorGroup(%deplObj.getTarget(), %client.team);

	     // place the deployable in the MissionCleanup/Deployables group (AI reasons)
	     addToDeployGroup(%deplObj);

	     //let the AI know as well...
	     AIDeployObject(%client, %deplObj);

	     // play the deploy sound
	     serverPlay3D(%item.deploySound, %deplObj.getTransform());

	     // increment the team count for this deployed object
	     $TeamDeployedCount[%deplObj.team, TiberiumRefineryDeployable]++;

	     addDSurface(%item.surface,%deplObj);

	     %deplObj.playThread($PowerThread,"Power");

         $BuildingCount::TiberiumRefinery[%deplObj.team]++;
         $Power[%deplObj.team] = $Power[%deplObj.team] - 50;

         %count = ClientGroup.getCount();
            for(%i = 0; %i < %count; %i++) {
               %cl = ClientGroup.getObject(%i);
               if(%cl.team == %deplObj.team) {
                  messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, Tiberium Refinery.");
               }
            }
         CheckPowerLowLevel(%deplObj.team);

         Add700Loop(%deplObj);
         echo("C&C: Team "@%deplObj.team@" Built a Tiberium Refinery at "@%deplObj.getPosition()@".");
      }
      //////////////
      else if(%objToDeploy $= "WarFact") {
         %deplObj = new (StaticShape)() {
            dataBlock = DeployedWeaponsFactory;
	        scale = "4.5 4.5 1";
	        deployed = true;
         };
         %deplObj.team = %team;
         %deplObj.team.WeaponsFactoryCount++;

         if(%deplObj.team == 1 || %deplObj.team == 3 || %deplObj.team == 6) {
	        setTargetName(%deplObj.target,addTaggedString("War Factory"));
         }
         else {
	        setTargetName(%deplObj.target,addTaggedString("Weapons Factory"));
         }
         $BuildingCount::WeaponsFactory[%deplObj.team]++;

         addDSurface(%item.surface,%deplObj);

         if(%deplObj.getTarget() != -1)
            setTargetSensorGroup(%deplObj.getTarget(), %client.team);

         addToDeployGroup(%deplObj);
         AIDeployObject(%client, %deplObj);

         // play the deploy sound
         serverPlay3D(%item.deploySound, %deplObj.getTransform());

         $TeamDeployedCount[%deplObj.team, WeaponsFactoryDeployable]++;

         %deplObj.deploy();

         // Adjust the trigger object
         adjustTrigger(%deplObj);

         %count = ClientGroup.getCount();
         for(%i = 0; %i < %count; %i++) {
            %cl = ClientGroup.getObject(%i);
            if(%cl.team == %deplObj.team) {
               if(%deplObj.team == 1 || %deplObj.team == 3 || %deplObj.team == 6)
               messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, War Factory.");
               else
               messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, Weapons Factory.");
            }
         }
         echo("C&C: Team "@%deplObj.team@" Built a Weapons Factory at "@%deplObj.getPosition()@".");
      }
      //////////////
   //Orient The Building To The Pad
   //I really dont trust %item.surface to do that properly
   //Oh, and I even make it rotate relavtive to the Pad :)
   %deplObj.setTransform(%obj.getPosition() SPC %obj.SetUpRotationism);
   //And this is for 'Sell Building'
   %deplObj.OwnerClientGUID = %client.GUID;
   //Blow up the pad, it's no longer needed.
   %obj.delete();
}

function TestBuildPreqs(%client) {
echo("Adv Guard: "@$Building::HasAdvGuard[%client]@"");
echo("Adv Power: "@$Building::HasAdvPower[%client]@"");
echo("Barracks: "@$Building::HasBarracks[%client]@"");
echo("Comm Center: "@$Building::HasCommCenter[%client]@"");
echo("Enrich: "@$Building::HasEnrich[%client]@"");
echo("AA Battery: "@$Building::HasAABat[%client]@"");
echo("Guard Tower: "@$Building::HasGuardTower[%client]@"");
echo("Ion Control: "@$Building::HasIonControl[%client]@"");
echo("Gun Turret: "@$Building::HasGunTurret[%client]@"");
echo("Obelisk: "@$Building::HasObelisk[%client]@"");
echo("Sam Site: "@$Building::HasSAMSite[%client]@"");
echo("NPA Laser: "@$Building::HasNPALaser[%client]@"");
echo("NPA Part: "@$Building::HasNPAParticle[%client]@"");
echo("Power Plant: "@$Building::HasPowerPlant[%client]@"");
echo("Temple Of Nod: "@$Building::HasTempleOfNod[%client]@"");
echo("Tib Refinery: "@$Building::HasTibRefinery[%client]@"");
echo("War Fact: "@$Building::HasWarFact[%client]@"");
}
