datablock PrecipitationData(CMDRain)
{
   type = 0;
// soundProfile = "Universal_Rain_Light_1"; We don't want the sound to be playing..
   materialList = "raindrops.dml";
   sizeX = 0.2;
   sizeY = 0.45;

   movingBoxPer = 0.35;
   divHeightVal = 1.5;
   sizeBigBox = 1;
   topBoxSpeed = 20;
   frontBoxSpeed = 30;
   topBoxDrawPer = 0.5;
   bottomDrawHeight = 40;
   skipIfPer = -0.3;
   bottomSpeedPer = 1.0;
   frontSpeedPer = 1.5;
   frontRadiusPer = 0.5;

};

datablock LinearProjectileData(HailProjectile)
{
   projectileShapeName = "disc.dts";
   emitterDelay        = -1;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.35;
   damageRadius        = 10.5;
   radiusDamageType    = $DamageType::Hail;
   kickBackStrength    = 1750;

   sound 				= discProjectileSound;
   explosion           = "DiscExplosion";
   underwaterExplosion = "UnderwaterDiscExplosion";
   splash              = DiscSplash;

   dryVelocity       = 300;
   wetVelocity       = 250;
   velInheritFactor  = 0.5;
   fizzleTimeMS      = 5000;
   lifetimeMS        = 5000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 15.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 5000;

   activateDelayMS = 200;

   hasLight    = true;
   lightRadius = 6.0;
   lightColor  = "0.175 0.175 0.5";
};

function ThunderstormMapLoop() {
    if($CurrentMission !$= "Thunderstorm") {
    //stop the loop if were out of this map
    return;
    }
    %type = getRandom(1,4);
    switch(%type) {
       case 1:
       ThunderstormNoLightning();
       echo("C&C: Map Event: Thunderstorm: No Lightning");
       case 2:
       ThunderstormRegularLightning();
       echo("C&C: Map Event: Thunderstorm: Regular Lightning");
       case 3:
       ThunderstormSevereLightning();
       echo("C&C: Map Event: Thunderstorm: Severe Lightning & Hail");
       case 4:
       ThunderstormClearSky();
       echo("C&C: Map Event: Thunderstorm: Skies Clearing");
       default:
       ThunderstormRegularLightning();
       echo("C&C: Map Event: Thunderstorm: Regular Lightning");
    }
    schedule(120000,0,"ThunderstormMapLoop"); //Cycle Every 2 Minutes
}
function ThunderstormClearSky() {
    if($MapEvent::LightningType["Thunderstorm"] != 4) {
    MessageAll('MsgLightningWarning', "\c5The skies are slowly clearing.");
    Precipitation.Delete();
    Storm.Delete();
    RainSound.delete();
    }
    Sky.Stormfog(0,1);
    $MapEvent::LightningType["Thunderstorm"] = 4;
}
function ThunderstormNoLightning() {
    if($MapEvent::LightningType["Thunderstorm"] != 1) {
    MessageAll('MsgLightningWarning', "\c5Thunderstorm Calming, Lightning may be occasional.");
    }
    if($MapEvent::LightningType["Thunderstorm"] == 4) {
	new Precipitation(Precipitation) {
		position = "-336.859 -631.623 191.648";
		rotation = "1 0 0 0";
		scale = "1 1 1";
		dataBlock = "CMDRain"; //sound fix
		lockCount = "0";
		homingCount = "0";
		percentage = "1";
		color1 = "0.700000 0.700000 0.720000 1.000000";
		color2 = "-1.000000 0.000000 0.000000 1.000000";
		color3 = "-1.000000 0.000000 0.000000 1.000000";
		offsetSpeed = "0.25";
		minVelocity = "1.25";
		maxVelocity = "4";
		maxNumDrops = "2000";
		maxRadius = "80";

		locked = "true";
	};
   new AudioEmitter(RainSound) {
         position = "0 0 0";
         rotation = "1 0 0 0";
         scale = "1 1 1";
         soundProfile = "Universal_Rain_Light_1";
         Datablock = "Universal_Rain_Light_1";
         useProfileDescription = "0";
         outsideAmbient = "1";
         volume = "1";
         isLooping = "1";
         is3D = "1";
         minDistance = "99999";
         maxDistance = "99999";
         coneInsideAngle = "360";
         coneOutsideAngle = "360";
         coneOutsideVolume = "1";
         coneVector = "0 0 1";
         loopCount = "-1";
         minLoopGap = "1000";
         maxLoopGap = "3000";
         type = "EffectAudioType";
         locked = "true";
   };
	new Lightning(Storm) {
		position = "-648 -720 100";
		rotation = "1 0 0 0";
		scale = "1768 1904 300";
		dataBlock = "DefaultStorm";
		strikesPerMinute = "4";
		strikeWidth = "2.5";
		chanceToHitTarget = "0.95";
		strikeRadius = "20";
		boltStartRadius = "20";
		color = "1.000000 1.000000 1.000000 1.000000";
		fadeColor = "0.300000 0.300000 1.000000 1.000000";
		useFog = "1";
			locked = "true";
	};
    }
    $MapEvent::LightningType["Thunderstorm"] = 1;
    Sky.Stormfog(1,1);
    Storm.Delete();
	new Lightning(Storm) {
		position = "-648 -720 100";
		rotation = "1 0 0 0";
		scale = "1768 1904 300";
		dataBlock = "DefaultStorm";
		strikesPerMinute = "4";
		strikeWidth = "2.5";
		chanceToHitTarget = "0.95";
		strikeRadius = "20";
		boltStartRadius = "20";
		color = "1.000000 1.000000 1.000000 1.000000";
		fadeColor = "0.300000 0.300000 1.000000 1.000000";
		useFog = "1";
			locked = "true";
	};
}
function ThunderstormRegularLightning() {
    if($MapEvent::LightningType["Thunderstorm"] != 2) {
    MessageAll('MsgLightningWarning', "\c5WARNING: Severe Thunderstorm Warning, Lightning May Be Severe. ~wfx/misc/red_alert_short.wav");
    }
    if($MapEvent::LightningType["Thunderstorm"] == 4) {
	new Precipitation(Precipitation) {
		position = "-336.859 -631.623 191.648";
		rotation = "1 0 0 0";
		scale = "1 1 1";
		dataBlock = "CMDRain"; //sound fix
		lockCount = "0";
		homingCount = "0";
		percentage = "1";
		color1 = "0.700000 0.700000 0.720000 1.000000";
		color2 = "-1.000000 0.000000 0.000000 1.000000";
		color3 = "-1.000000 0.000000 0.000000 1.000000";
		offsetSpeed = "0.25";
		minVelocity = "1.25";
		maxVelocity = "4";
		maxNumDrops = "2000";
		maxRadius = "80";

		locked = "true";
	};
   new AudioEmitter(RainSound) {
         position = "0 0 0";
         rotation = "1 0 0 0";
         scale = "1 1 1";
         soundProfile = "Universal_Rain_Light_1";
         Datablock = "Universal_Rain_Light_1";
         useProfileDescription = "0";
         outsideAmbient = "1";
         volume = "1";
         isLooping = "1";
         is3D = "1";
         minDistance = "99999";
         maxDistance = "99999";
         coneInsideAngle = "360";
         coneOutsideAngle = "360";
         coneOutsideVolume = "1";
         coneVector = "0 0 1";
         loopCount = "-1";
         minLoopGap = "1000";
         maxLoopGap = "3000";
         type = "EffectAudioType";
         locked = "true";
   };
	new Lightning(Storm) {
		position = "-648 -720 100";
		rotation = "1 0 0 0";
		scale = "1768 1904 300";
		dataBlock = "DefaultStorm";
		strikesPerMinute = "4";
		strikeWidth = "2.5";
		chanceToHitTarget = "0.95";
		strikeRadius = "20";
		boltStartRadius = "20";
		color = "1.000000 1.000000 1.000000 1.000000";
		fadeColor = "0.300000 0.300000 1.000000 1.000000";
		useFog = "1";
			locked = "true";
	};
    }
    $MapEvent::LightningType["Thunderstorm"] = 2;
    Sky.Stormfog(4,1);
    Storm.Delete();
	new Lightning(Storm) {
		position = "-648 -720 100";
		rotation = "1 0 0 0";
		scale = "1768 1904 300";
		dataBlock = "DefaultStorm";
		strikesPerMinute = "20";
		strikeWidth = "2.5";
		chanceToHitTarget = "0.95";
		strikeRadius = "20";
		boltStartRadius = "20";
		color = "1.000000 1.000000 1.000000 1.000000";
		fadeColor = "0.300000 0.300000 1.000000 1.000000";
		useFog = "1";
			locked = "true";
	};
}
function ThunderstormSevereLightning() {
    if($MapEvent::LightningType["Thunderstorm"] != 3) {
    MessageAll('MsgLightningWarning', "\c5WARNING: TORNADO WARNING ISSUED, HEAVY LIGHTNING WARNING!!! ~wfx/misc/red_alert.wav");
    MessageAll('MsgLightningWarning', "\c5WARNING: LARGE HAILSTONES ARE PRESENT!!! ~wfx/misc/red_alert.wav");
    }
    if($MapEvent::LightningType["Thunderstorm"] == 4) {
	new Precipitation(Precipitation) {
		position = "-336.859 -631.623 191.648";
		rotation = "1 0 0 0";
		scale = "1 1 1";
		dataBlock = "CMDRain"; //sound fix
		lockCount = "0";
		homingCount = "0";
		percentage = "1";
		color1 = "0.700000 0.700000 0.720000 1.000000";
		color2 = "-1.000000 0.000000 0.000000 1.000000";
		color3 = "-1.000000 0.000000 0.000000 1.000000";
		offsetSpeed = "0.25";
		minVelocity = "1.25";
		maxVelocity = "4";
		maxNumDrops = "2000";
		maxRadius = "80";

		locked = "true";
	};
   new AudioEmitter(RainSound) {
         position = "0 0 0";
         rotation = "1 0 0 0";
         scale = "1 1 1";
         soundProfile = "Universal_Rain_Light_1";
         Datablock = "Universal_Rain_Light_1";
         useProfileDescription = "0";
         outsideAmbient = "1";
         volume = "1";
         isLooping = "1";
         is3D = "1";
         minDistance = "99999";
         maxDistance = "99999";
         coneInsideAngle = "360";
         coneOutsideAngle = "360";
         coneOutsideVolume = "1";
         coneVector = "0 0 1";
         loopCount = "-1";
         minLoopGap = "1000";
         maxLoopGap = "3000";
         type = "EffectAudioType";
         locked = "true";
   };
	new Lightning(Storm) {
		position = "-648 -720 100";
		rotation = "1 0 0 0";
		scale = "1768 1904 300";
		dataBlock = "DefaultStorm";
		strikesPerMinute = "4";
		strikeWidth = "2.5";
		chanceToHitTarget = "0.95";
		strikeRadius = "20";
		boltStartRadius = "20";
		color = "1.000000 1.000000 1.000000 1.000000";
		fadeColor = "0.300000 0.300000 1.000000 1.000000";
		useFog = "1";
			locked = "true";
	};
    }
    $MapEvent::LightningType["Thunderstorm"] = 3;
    hailstones();
    Sky.Stormfog(10,1);
    Storm.Delete();
	new Lightning(Storm) {
		position = "-648 -720 100";
		rotation = "1 0 0 0";
		scale = "1768 1904 300";
		dataBlock = "DefaultStorm";
		strikesPerMinute = "60";
		strikeWidth = "2.5";
		chanceToHitTarget = "0.95";
		strikeRadius = "20";
		boltStartRadius = "20";
		color = "1.000000 1.000000 1.000000 1.000000";
		fadeColor = "0.300000 0.300000 1.000000 1.000000";
		useFog = "1";
			locked = "true";
	};
}

function hailstones() {
   if($MapEvent::LightningType["Thunderstorm"] != 3) {
   return; //cancel
   }
    if($CurrentMission !$= "Thunderstorm") {
    //stop the loop if were out of this map
    return;
    }
   for(%i = 0; %i < 320; %i++) {
   %time = %i * (25 / 2);
   Schedule(%time,0,"SpawnProjectile","LinearProjectile", "HailProjectile", vectorAdd("-70 -238 1000", getRandomPosition(800,1)), "0 0 -100", "");
   }
   schedule(4000,0,"hailstones");
}
