// ------------------------------------------------------------------

datablock ShapeBaseImageData(ActiveCamoPackImage)
{
   shapeFile = "pack_upgrade_sensorjammer.dts";
   item = ActiveCamoPack;
   mountPoint = 1;
   offset = "0 0 0";

   usesEnergy = true;
   minEnergy = 3;

   stateName[0] = "Idle";
   stateTransitionOnTriggerDown[0] = "Activate";

   stateName[1] = "Activate";
   stateScript[1] = "onActivate";
   stateSequence[1] = "fire";
   //stateSound[1] = CloakingPackActivateSound;
   stateEnergyDrain[1] = 0; //nope
   stateTransitionOnTriggerUp[1] = "Deactivate";
   stateTransitionOnNoAmmo[1] = "Deactivate";

   stateName[2] = "Deactivate";
   stateScript[2] = "onDeactivate";
   stateTransitionOnTimeout[2] = "Idle";
};

datablock ItemData(ActiveCamoPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "pack_upgrade_sensorjammer.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "ActiveCamoPackImage";
   pickUpName = "Active Camoflague";

   computeCRC = true;

};

function ActiveCamoPackImage::onMount(%data, %obj, %node)
{
   // player is sensor-invisible while wearing pack (except to motion sensors)
   %obj.setPassiveJammed(true);
}

function ActiveCamoPackImage::onUnmount(%data, %obj, %node)
{
   setTargetSensorData(%obj.client.target, PlayerSensor);
   %obj.setPassiveJammed(false);
   %obj.setCloaked(false);
   %obj.setImageTrigger(%node, false);
}

// make player completely invisible to all players/sensors (except motion)
function ActiveCamoPackImage::onActivate(%data, %obj, %slot)
{
   if(%obj.reCloak !$= "")
   {
      Cancel(%obj.reCloak);
      %obj.reCloak = "";
   }
      // can the player currently cloak (function returns "true" or reason for failure)?
      if(%obj.canCloak() $= "true")
      {
         messageClient(%obj.client, 'MsgActiveCamoPackOn', '\c2Active Camoflague Activated.');
         if(%obj.client.Arby3 == 1)
         setTargetSensorData(%obj.client.target, JammerSensorObjectActive);
         %obj.setCloaked(true);
         if ( !isDemo() )
            commandToClient( %obj.client, 'setCloakIconOn' );
      }
      else
      {
         // notify player that they cannot cloak
         messageClient(%obj.client, 'MsgActiveCamoPackFailed', '\c2Active Camoflague Jammed.');
         %obj.setImageTrigger(%slot, false);
         setTargetSensorData(%obj.client.target, PlayerSensor);
      }
}

function ActiveCamoPackImage::onDeactivate(%data, %obj, %slot)
{
   if(%obj.reCloak !$= "")
   {
      Cancel(%obj.reCloak);
      %obj.reCloak = "";
   }

   // if pack is not on then dont bother...
   if(%obj.getImageState($BackpackSlot) $= "activate")
      messageClient(%obj.client, 'MsgActiveCamoPackOn', '\c2Active Camoflague Deactivated.');

   %obj.setCloaked(false);
   setTargetSensorData(%obj.client.target, PlayerSensor);
   %obj.setImageTrigger(%slot, false);
   if ( !isDemo() )
      commandToClient( %obj.client, 'setCloakIconOff' );
}

function ActiveCamoPack::onPickup(%this, %obj, %shape, %amount)
{
   // created to prevent console errors
}
