// turretpack.cs - turret pack
//

datablock SensorData(AdvGuardTurretSensor)
{
   detects = true;
   detectsUsingLOS = true;
   detectsPassiveJammed = false;
   detectsActiveJammed = false;
   detectsCloaked = false;
   detectionPings = true;
   detectRadius = 350;
};

datablock ShapeBaseImageData(AdvGuardTurretDeployableImage)
{
mass = 1;
emap = true;

shapeFile = "stackable1s.dts";
item = AdvGuardTurretBasePack;
mountPoint = 1;
offset = "0 -0.2 0";

minDeployDis = 0.5;
maxDeployDis = 5.0;

deployed = AdvGuardTurretDeployedBase;
heatSignature = 0;

stateName[0] = "Idle";
stateTransitionOnTriggerDown[0] = "Activate";



stateName[1] = "Activate";
stateScript[1] = "onActivate";
stateTransitionOnTriggerUp[1] = "Idle";

isLarge = true;
maxDepSlope = 360;
deploySound = StationDeploySound;
};

datablock ItemData(AdvGuardTurretBasePack)
{
className = Pack;
catagory = "Deployables";
shapeFile = "stackable1s.dts";
mass = 1;
elasticity = 0.2;
friction = 0.6;
pickupRadius = 1;
rotate = false;
image = "AdvGuardTurretDeployableImage";
pickUpName = "a Obelisk turret pack";
heatSignature = 0;

computeCRC = true;
emap = true;

};

datablock TurretData(AdvGuardTowerCGBase) : TurretDamageProfile
{
className = DeployedTurret;
shapeFile = "turret_base_large.dts";

rechargeRate = 0.31;

selfPower = true;

needsPower = false;
mass = 1;
maxDamage = 2.25;
destroyedLevel = 2.25;
disabledLevel = 2.05;
repairRate = 0;
explosion = TurretExplosion;
expDmgRadius = 15.0;
expDamage = 0.7;
expImpulse = 2000.0;

deployedObject = true;

thetaMin = 15;
thetaMax = 140;
//thetaNull = 90;

isShielded = false; //dual shielding = bad
energyPerDamagePoint = 50;
maxEnergy = 150;

humSound = SensorHumSound;
heatSignature = 1;
pausePowerThread = true;

canControl = false;
cmdCategory = "DTactical";
cmdIcon = CMDTurretIcon;
cmdMiniIconName = "commander/MiniIcons/com_turret_grey";
targetNameTag = 'Adv. Guard Tower (CG)';
targetTypeTag = '';
sensorData = AdvGuardTurretSensor;
sensorRadius = 350;
sensorColor = "0 212 45";
powerCount = 1;

firstPersonOnly = true;

debrisShapeName = "debris_generic.dts";
debris = TurretDebris;
};

datablock TurretData(AdvGuardTurretDeployedBase) : TurretDamageProfile
{
className = DeployedTurret;
shapeFile = "turret_base_large.dts";

rechargeRate = 0.31;

selfPower = true;

needsPower = false;
mass = 1;
maxDamage = 2.25;
destroyedLevel = 2.25;
disabledLevel = 2.05;
repairRate = 0;
explosion = TurretExplosion;
expDmgRadius = 15.0;
expDamage = 0.7;
expImpulse = 2000.0;

deployedObject = true;

thetaMin = 15;
thetaMax = 140;
//thetaNull = 90;

isShielded = false;
energyPerDamagePoint = 50;
maxEnergy = 150;

humSound = SensorHumSound;
heatSignature = 1;
pausePowerThread = true;

canControl = true;
cmdCategory = "DTactical";
cmdIcon = CMDTurretIcon;
cmdMiniIconName = "commander/MiniIcons/com_turret_grey";
targetNameTag = 'Adv. Guard Tower';
targetTypeTag = '';
sensorData = AdvGuardTurretSensor;
sensorRadius = 350;
sensorColor = "0 212 45";
powerCount = 1;

firstPersonOnly = true;

debrisShapeName = "debris_generic.dts";
debris = TurretDebris;
};

function AdvGuardTurretBasePack::onPickup(%this, %obj, %shape, %amount)
{
// created to prevent console errors
}

function AdvGuardTurretDeployableImage::onDeploy(%item, %plyr, %slot)
{
    if($BuildingCount::PowerPlant[%plyr.client.team] <= 0) {
    messageclient(%plyr.client, 'MsgClient', '\c5Tech Error, Power Plant Required.');
    return;
    }
    if($BuildingCount::CommCenter[%plyr.client.team] <= 0) {
    messageclient(%plyr.client, 'MsgClient', '\c5Tech Error, Communications Center Required.');
    return;
    }

%deplObj = Parent::onDeploy(%item, %plyr, %slot);
%origBarrel = %item.item.origBarrel;
if(%origBarrel !$= "")
{
%deplObj.mountImage(%origBarrel, 0, false);
%item.item.origBarrel = "";
}

%deplObj.mountImage("ADVGuardBarrelLarge", 0);

addDSurface(%item.surface,%deplObj);
addToDeployGroup(%deplObj);
%deplObj.powerFreq = %plyr.powerFreq;
%deplObj.team = %plyr.team;

%deplObj.getDataBlock().onGainPowerEnabled(%deplObj);
%deplObj.getDataBlock().GainPower(%deplObj);
%deplObj.powerCount = 1;

//CG Turret
	%turret = new (Turret)() {
		dataBlock = AdvGuardTowerCGBase;
        scale = "0.5 0.5 0.5";
		deployed = true;
	};
   MissionCleanup.add(%turret);
   %turret.team = %deplObj.team;
   %turret.setSelfPowered();
   %turret.getDataBlock().onGainPowerEnabled(%turret);
   %turret.getDataBlock().GainPower(%turret);
   %turret.powerCount = 1;
   %deplObj.mountObject(%turret, 10);
   %turret.setCapacitorRechargeRate(999);
   %turret.mountobj = %deplObj;
   %deplObj.turretObject = %turret;
   %turret.team = %deplObj.team;
   %turret.base = %deplObj;
   setTargetSensorGroup(%turret.getTarget(),%turret.team);
   %turret.mountImage("GuardBarrelLarge", 0);
   %turret.setAutoFire(true); //YES

      %count = ClientGroup.getCount();
      for(%i = 0; %i < %count; %i++) {
         %cl = ClientGroup.getObject(%i);
         if(%cl.team == %deplObj.team) {
            messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, Adv. Guard Tower.");
         }
      }

    $Power[%deplObj.team] = $Power[%deplObj.team] - 150;
    CheckPowerLowLevel(%deplObj.team);
    $BuildingCount::AdvGuardTurret[%deplObj.team]++;
    echo("C&C: Team "@%deplObj.team@" Built an Adv. Guard Tower at "@%deplObj.getPosition()@".");
}

function AdvGuardTurretDeployedBase::onDestroyed(%this,%obj,%prevState) {

      if(isObject(%obj.turretObject)) {
      %obj.turretObject.delete();
      }
      %count = ClientGroup.getCount();
      for(%i = 0; %i < %count; %i++) {
         %cl = ClientGroup.getObject(%i);
         if(%cl.team == %obj.team) {
            messageclient(%cl, 'MsgClient', "\c5Base Update: Building Lost, Adv. Guard Tower.");
         }
      }

    $BuildingCount::AdvGuardTurret[%obj.team]--;
    $Power[%obj.team] = $Power[%obj.team] + 150;
   CheckPowerGoodLevel(%obj.team);
   $TeamDeployedCount[%obj.team,AdvGuardTurretBasePack]--;
   remDSurface(%obj);
   %obj.schedule(500,"delete");
   if($Game::PlayingCnC) {
   $TeamScore[%obj.lastDamagedByTeam] = $TeamScore[%obj.lastDamagedByTeam] + $CNC::Score[AdvGuardTower];
   }
   Parent::onDestroyed(%data,%obj,%prevState);
}

function AdvGuardTurretDeployableImage::onMount(%data, %obj, %node) {

}

function AdvGuardTowerCGBase::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   setTargetSensorGroup(%obj.target, %obj.team);
   //setTargetNeverVisMask(%obj.target, 0xffffffff);
}

function AdvGuardTowerCGBase::onDamage(%data, %obj)
{
   %newDamageVal = %obj.getDamageLevel();
   if(%obj.lastDamageVal !$= "")
      if(isObject(%obj.getObjectMount()) && %obj.lastDamageVal > %newDamageVal)
         %obj.getObjectMount().setDamageLevel(%newDamageVal);
   %obj.lastDamageVal = %newDamageVal;
}

function AdvGuardTowerCGBase::damageObject(%this, %targetObject, %sourceObject, %position, %amount, %damageType ,%vec, %client, %projectile)
{
   %tur = %targetObject.getObjectMount();
   if(%tur)
      %tur.getDataBlock().damageObject(%tur, %sourceObject, %position, %amount, %damageType, %vec, %client, %projectile);
}
