//--------------------------------------------------------------------------
// Deployable Generator
//--------------------------------------------------------------------------

datablock ParticleData(RiftIonCannonParticle) {
	dragCoeffiecient     = 0.0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.0;

	lifetimeMS           = 2000;
	lifetimeVarianceMS   = 0;

	textureName          = "particleTest";

	useInvAlpha = false;
	spinRandomMin = -160.0;
	spinRandomMax = 160.0;

    textureName  = "flarebase";

	colors[0]     = "0 1 0";
	colors[1]     = "0 1 0";
	colors[2]     = "0 1 0";
	colors[3]     = "0 1 0";
	sizes[0]      = 10;
	sizes[1]      = 20;
	sizes[2]      = 30;
    sizes[3]      = 30;
	times[0]      = 0.0;
	times[1]      = 0.01;
	times[2]      = 0.02;
    times[3]      = 1;
};

datablock ParticleEmitterData(RiftIonCannonEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;

   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   spinRandomMin   = "200";
   spinRandomMax   = "-200";
   overrideAdvances = false;
   particles = "RiftIonCannonParticle";
};

datablock LinearFlareProjectileData(RiftIonCannonLaser)
{
   projectileShapeName = "plasmabolt.dts";
   scale               = "0.5 0.5 0.5";
   faceViewer          = true;
   directDamage        = 1.7; //die.
   hasDamageRadius     = true;
   indirectDamage      = 0.9;
   damageRadius        = 55;
   kickBackStrength    = 150.0;
   radiusDamageType    = $DamageType::IonCannon; //Cause Ze Burn

   explosion           = "MainNuclearExplosion";
   splash              = NuclearSplash;
   baseEmitter         = RiftIonCannonEmitter;
   dryVelocity       = 1000.0;
   wetVelocity       = 1000.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 17000;
   lifetimeMS        = 17000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 0;

   activateDelayMS = -1;

   size[0]           = 0.01;
   size[1]           = 0.01;
   size[2]           = 0.01;

   numFlares         = 1;
   flareColor        = "0 0 1";
   flareModTexture   = "special/stationglow";//"special/sniper00";//"special/stationglow";//"flaremod";
   flareBaseTexture  = "special/lightFalloffMono";//"flarebase";

   hasLight    = false;
   lightRadius = 1.0;
   lightColor  = "0 0 1";

};



///////////////////
//BUILDING
datablock SensorData(EnrichGeneratorSensorObj)
{
   detects = true;
   detectsUsingLOS = true;
   detectsPassiveJammed = true;
   detectsActiveJammed = true;
   detectsCloaked = false;
   detectionPings = true;
   detectRadius = 2000;
};


datablock StaticShapeData(DeployedEnrichGenerator) : StaticShapeDamageProfile {
   className = Sensor;
   catagory = "Sensors";
   shapeFile = "stackable3m.dts";
   maxDamage = 4.0;
   destroyedLevel = 4.0;
   disabledLevel = 3.85;
   explosion      = ShapeExplosion;
   expDmgRadius = 10.0;
   expDamage = 0.5;
   expImpulse = 2000.0;

   dynamicType = $TypeMasks::StaticShapeObjectType;
   isShielded = true;
   energyPerDamagePoint = 33;
   maxEnergy = 110;
   rechargeRate = 0.31;
   ambientThreadPowered = true;
   humSound = SensorHumSound;

   cmdCategory = "Support";
   cmdIcon = CMDSensorIcon;
   cmdMiniIconName = "commander/MiniIcons/com_sensor_grey";
   targetNameTag = 'Enrich Generator';
   targetTypeTag = '';
   sensorData = EnrichGeneratorSensorObj;
   sensorRadius = EnrichGeneratorSensorObj.detectRadius;
   sensorColor = "255 194 9";

   debrisShapeName = "debris_generic.dts";
   debris = StaticShapeDebris;
};


datablock ShapeBaseImageData(EnrichGeneratorImage) {
	mass = 20;
	emap = true;
	shapeFile = "stackable1s.dts";
	item = EnrichGeneratorDeployable;
	mountPoint = 1;
	offset = "0 0 0";
	deployed = DeployedEnrichGenerator;
	heatSignature = 0;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";

	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateTransitionOnTriggerUp[1] = "Idle";

	isLarge = true;
	maxDepSlope = 360;
	deploySound = ItemPickupSound;

	minDeployDis = 2;
	maxDeployDis = 5;
};

datablock ItemData(EnrichGeneratorDeployable) {
	className = Pack;
	catagory = "Deployables";
	shapeFile = "stackable1s.dts";
	mass = 5.0;

	hasLight = true;
	lightType = "PulsingLight";
	lightColor = "0.1 0.8 0.8 1.0";
	lightTime = "1000";
	lightRadius = "3";

	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 3;
	rotate = true;
	image = "EnrichGeneratorImage";
	pickUpName = "a Power Plant";
	heatSignature = 0;
	emap = true;
};

function EnrichGeneratorImage::testNoTerrainFound(%item) {
	// don't check this for non-Landspike turret deployables
}

function EnrichGeneratorDeployable::onPickup(%this, %obj, %shape, %amount) {
	// created to prevent console errors
}

function EnrichGeneratorImage::onDeploy(%item, %plyr, %slot) {

    if($BuildingCount::PowerPlant[%plyr.client.team] <= 0) {
    messageclient(%plyr.client, 'MsgClient', '\c5Tech Error, Power Plant Required.');
    return;
    }
    if($BuildingCount::CommCenter[%plyr.client.team] <= 0) {
    messageclient(%plyr.client, 'MsgClient', '\c5Tech Error, Communications Center Required.');
    return;
    }
    if($CNC::EnrichGenerator[%plyr.client.team] !$= "") {
    messageclient(%plyr.client, 'MsgClient', '\c5Similarity Error, Structure Already Exists.');
    return;
    }

	%className = "StaticShape";

	%playerVector = vectorNormalize(getWord(%plyr.getEyeVector(),1) SPC -1 * getWord(%plyr.getEyeVector(),0) SPC "0");

	if (vAbs(floorVec(%item.surfaceNrm,100)) $= "0 0 1")
		%item.surfaceNrm2 = vectorScale(%playerVector,-1);
	else
		%item.surfaceNrm2 = vectorNormalize(vectorCross(%item.surfaceNrm,"0 0 1"));

	%rot = fullRot(%item.surfaceNrm,%item.surfaceNrm2);

	%item.surfacePt = vectorAdd(%item.surfacePt,vectorScale(vectorNormalize(vectorCross(%item.surfaceNrm,%item.surfaceNrm2)),2));

	%deplObj = new (StaticShape)() {
		dataBlock = DeployedEnrichGenerator;
        scale = "10 10 10";
		deployed = true;
	};

	// set orientation
	%deplObj.setTransform(%item.surfacePt SPC %rot);

	// set team, owner, and handle
	%deplObj.team = %plyr.client.Team;

	// set power frequency
	%deplObj.powerFreq = %plyr.powerFreq;

	// set power
	%deplObj.setSelfPowered();

	// set the sensor group if it needs one
	if (%deplObj.getTarget() != -1)
		setTargetSensorGroup(%deplObj.getTarget(), %plyr.client.team);

	// place the deployable in the MissionCleanup/Deployables group (AI reasons)
	addToDeployGroup(%deplObj);

	//let the AI know as well...
	AIDeployObject(%plyr.client, %deplObj);

	// play the deploy sound
	serverPlay3D(%item.deploySound, %deplObj.getTransform());

	// increment the team count for this deployed object
	$TeamDeployedCount[%plyr.client.team, EnrichGeneratorDeployable]++;

	addDSurface(%item.surface,%deplObj);

	%deplObj.playThread($PowerThread,"Power");

    $BuildingCount::EnrichGenerator[%deplObj.team]++;
    $Power[%deplObj.team] = $Power[%deplObj.team] - 250; //Add 250 Power From The Team Count
    %deplObj.team.EnrichGeneratorCount++;

	// take the deployable off the player's back and out of inventory
	%plyr.unmountImage(%slot);
	%plyr.decInventory(%item.item, 1);

      %count = ClientGroup.getCount();
      for(%i = 0; %i < %count; %i++) {
         %cl = ClientGroup.getObject(%i);
         if(%cl.team == %deplObj.team) {
         messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, Enrich Generator.");
         messageclient(%cl, 'MsgClient', "\c5Superweapon Update: Spacious Rift Charging.");
         }
         else {
         messageclient(%cl, 'MsgClient', "\c5Superweapon Update: WARNING: Enrich Generator Detected.");
         }
      }
    CheckPowerLowLevel(%deplObj.team);
    $CNC::EnrichGenerator[%deplObj.team] = %deplObj;   //one per team
    %deplObj.canFireRift = 0;
    %deplObj.RiftSched = schedule(600000,0,"RiftReady",%deplObj);
    $SuperweaponTimer::Rift[%deplObj.team] = 600;
    schedule(1000,0,"DoRiftTimer", %deplObj);
    echo("C&C: Team "@%deplObj.team@" Built an Enrich Generator at "@%deplObj.getPosition()@".");
	return %deplObj;
}

function DoRiftTimer(%obj) {
   if(!isObject(%obj)) {
      $SuperweaponTimer::Rift[%obj.team] = 600;
      return;
   }
   if($SuperweaponTimer::Rift[%obj.team] == 0) {
      schedule(1000,0,"DoRiftTimer", %obj);
      return;
   }
   if($Power[%obj.team] < 0) {
      schedule(1000,0,"DoRiftTimer", %obj);
      return;
   }
   $SuperweaponTimer::Rift[%obj.team]--;
   schedule(1000,0,"DoRiftTimer", %obj);
}

function DeployedEnrichGenerator::onDestroyed(%this,%obj,%prevState) {

      %count = ClientGroup.getCount();
      for(%i = 0; %i < %count; %i++) {
         %cl = ClientGroup.getObject(%i);
         if(%cl.team == %obj.team) {
         messageclient(%cl, 'MsgClient', "\c5Base Update: Building Lost, Enrich Generator.");
         messageclient(%cl, 'MsgClient', "\c5Superweapon Update: Spacious Rift Disabled.");
         }
         else {
         messageclient(%cl, 'MsgClient', "\c5Superweapon Update: Enrich Generator Destroyed.");
         }
      }

   cancel(%obj.RiftSched);
   $SuperweaponTimer::Rift[%obj.team] = 600;
   $CNC::EnrichGenerator[%obj.team] = "";
   $BuildingCount::EnrichGenerator[%obj.team]--;
   $TeamDeployedCount[%obj.team,EnrichGeneratorDeployable]--;
   $Power[%obj.team] = $Power[%obj.team] + 250; //Remove 250 Power From The Team Count
   CheckPowerGoodLevel(%obj.team);
   %obj.team.EnrichGeneratorCount--;
   remDSurface(%obj);
   %obj.schedule(500,"delete");
   if($Game::PlayingCnC) {
   $TeamScore[%obj.lastDamagedByTeam] = $TeamScore[%obj.lastDamagedByTeam] + $CNC::Score[EnrichGenerator];
   }
   Parent::onDestroyed(%data,%obj,%prevState);
}

function EnrichGeneratorImage::onMount(%data,%obj,%node) {
	%obj.hasGen = true; // set for gencheck
}

function EnrichGeneratorImage::onUnmount(%data,%obj,%node) {
	%obj.hasGen = "";
}

//NUCLEAR MISSILE
function RiftReady(%obj) {
   %count = ClientGroup.getCount();
   for(%i = 0; %i < %count; %i++) {
      %cl = ClientGroup.getObject(%i);
      if(%cl.team == %obj.team) {
      messageclient(%cl, 'MsgClient', "\c5Superweapon Update: Spacious Rift Ready To Fire.");
      }
      else {
      messageclient(%cl, 'MsgClient', "\c5Superweapon Update: WARNING: ENEMY Spacious Rift Ready.");
      }
   }
   %obj.canFireRift = 1;
}

//Prep & Sound
datablock EffectProfile(RiftPrepEffect)
{
   effectname = "C&C/EnrichGenerator/RiftPrep";
   minDistance = 1;
   maxDistance = 500;
};

datablock AudioProfile(RiftPrepSound)
{
   filename    = "fx/vehicles/tank_activate.wav";
   description = AudioExplosion3d;
   effect = RiftPrepEffect;
};

function PrepRift(%obj, %pos) {
   if(!isObject(%obj)) {
   return;
   }
   %obj.canFireRift = 0;
   %obj.RiftSched = schedule(600000,0,"RiftReady",%obj);
   $SuperweaponTimer::Rift[%obj.team] = 600;
   %count = ClientGroup.getCount();
   for(%i = 0; %i < %count; %i++) {
      %cl = ClientGroup.getObject(%i);
      if(%cl.team == %obj.team) {
      messageclient(%cl, 'MsgClient', "\c5Enrich Generator Activating.");
      }
      else {
      messageclient(%cl, 'MsgClient', "\c5WARNING: A Spacial Disruption Has Been Detected. ~wfx/misc/red_alert_short.wav");
      }
   }
   serverPlay3D(RiftPrepSound, %obj.position);
   schedule(7500,0,"FireFakeRift",%obj, %pos);
   schedule(12000,0,"RiftDrop",%obj, %pos);
}

function FireFakeRift(%obj, %pos) {
   if(!isObject(%obj)) {
   return;
   }
   %count = ClientGroup.getCount();
   for(%i = 0; %i < %count; %i++) {
      %cl = ClientGroup.getObject(%i);
      if(%cl.team == %obj.team) {
      messageclient(%cl, 'MsgClient', "\c5Spacious Rifting Online, Shifting Dimensions In 5 seconds.");
      }
      else {
      messageclient(%cl, 'MsgClient', "\c5WARNING: Spacious Rift Opening Detected. ~wfx/misc/red_alert.wav");
      }
   }
}

function RiftDrop(%obj, %pos) {
   %nooke = new (LinearFlareProjectile)() {
   dataBlock = RiftIonCannonLaser;
   initialDirection = "0 0 -100";
   initialPosition = vectorAdd(%pos, "0 0 500");
//   sourceObject = %obj;
   damageFactor = 1;
   };
   MissionCleanup.Add(%nooke);
}


//Spacious Rift Funcitons
function RiftIonCannonLaser::onExplode(%data, %proj, %pos, %mod) {
StartSucking(%pos,0);
schedule(10000,0,"TheEnd",%pos);
}


function StartSucking(%pos, %cnt) {
 if(%cnt > 95) {
 return;
 }
 %cnt ++;
 %TargetSearchMask = $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType;
 InitContainerRadiusSearch(%pos,250,%TargetSearchMask);   //mega superweapon of death :)

   while ((%potentialTarget = ContainerSearchNext()) != 0){
      %dist = containerSearchCurrRadDamageDist();
      %tgtPos = %potentialTarget.getWorldBoxCenter();
      %distance2 =VectorDist(%tgtPos,%pos);
      %distance = mfloor(%distance2);
      %vec = VectorNormalize(VectorSub(%pos,%tgtpos));
      %nForce = -6000;                              //come here =-D
      %forceVector = vectorScale(%vec, -1*%nForce);

      if (%potentialTarget.getPosition() != %pos) {
         %potentialTarget.applyImpulse(%potentialTarget.getPosition(), %forceVector);
         }
    }
    schedule(100,0,"StartSucking",%pos, %cnt);
}

datablock ShockwaveData(BaseShockWave) {
	className = "ShockwaveData";
	scale = "1 1 1";
	delayMS = "0";
	delayVariance = "0";
	lifetimeMS = "12000";
	lifetimeVariance = "0";
	width = "5";
	numSegments = "20";
	numVertSegments = "10";
	velocity = "-30";
	height = "20";
	verticalCurve = "5";
	acceleration = "5";
	times[0] = "0";
	times[1] = "0.5";
	times[2] = "1";
	times[3] = "1";
	colors[0] = "0.000000 0.000000 0.500000 0.100000"; //1.0 0.9 0.9
	colors[1] = "0.500000 0.500000 1.000000 1.000000"; //0.6 0.6 0.6
	colors[2] = "0.500000 0.500000 1.000000 0.100000"; //0.6 0.6 0.6
	colors[3] = "1.000000 1.000000 1.000000 1.000000";
	texture[0] = "special/shockwave4";
	texture[1] = "special/gradient";
	texWrap = "7";
	is2D = "0";
	mapToTerrain = "0";
	orientToNormal = "1";
	renderBottom = "1";
	renderSquare = "0";
};


datablock ShockwaveData(DomeShockWave) {
	className = "ShockwaveData";
	delayMS = "0";
	delayVariance = "0";
	lifetimeMS = "8000";
	lifetimeVariance = "0";
	width = "5";
	numSegments = "80";
	numVertSegments = "10";
	velocity = "-200";
	height = "62";
	verticalCurve = "2.5";
	acceleration = "50";
	times[0] = "0";
	times[1] = "0.5";
	times[2] = "1";
	times[3] = "1";
	colors[0] = "1.000000 1.000000 0.500000 0.100000"; //1.0 0.9 0.9
	colors[1] = "1.000000 1.000000 0.500000 1.000000"; //0.6 0.6 0.6
	colors[2] = "1.000000 1.000000 0.500000 0.100000"; //0.6 0.6 0.6
	colors[3] = "1.000000 1.000000 1.000000 1.000000";
	texture[0] = "special/whitenoAlpha";
	texture[1] = "special/whitenoAlpha";
	texWrap = "7";
	orientToNormal = "1";
	renderBottom = "1";
        mapToTerrain = "0";
};

datablock ExplosionData(BaseExplosion)
        {
	className = "ExplosionData";
	particleDensity = "10";
	particleRadius = "1";
	explosionScale = "1 1 1";
	playSpeed = "1";
	Shockwave = "BaseShockWave";
	shockwaveOnTerrain = "0";
	lifetimeMS = "1000";
        };

datablock ExplosionData(DomeExplosion):BaseExplosion
          {
     	  Shockwave = "DomeShockWave";
          };

datablock TracerProjectileData(BaseProjectile) {
	className = "TracerProjectileData";
	Explosion = "BaseExplosion";
	dryVelocity = "0.1";
	wetVelocity = "0.1";
	fizzleTimeMS = "32";
	lifetimeMS = "32";
	explodeOnDeath = "1";
	crossSize = "0.1";
	renderCross = "0";
        isFXUnit = "1";
        };

datablock TracerProjectileData(DomeProjectile):BaseProjectile
        {
        hasDamageRadius     = true;
        indirectDamage      = 0.145;   //goodbye :)
        damageRadius        = 250;     //altough small, it is called 20 times.
        kickBackStrength    = 1000.0;
        radiusDamageType    = $DamageType::Rifted; //Cause Ze Burn
	    Explosion = "DomeExplosion";
        };


function shockwave(%pos,%nrm,%dat)
{
if (%dat $= "")
    %dat = BaseProjectile;

     %p1 = new TracerProjectile()
          {
           dataBlock        = %dat;
           initialDirection = %nrm;
           initialPosition  = %pos;
          };
}

$Pi = 3.1415926535897932;
function TheEnd(%pos) {
   for (%i=0; %i < 10;%i++) {
   %nrm = mCos(%i*$pi/10) SPC mSin(%i*$pi/10) SPC 0;
   shockwave(VectorAdd(%pos,VectorScale(%nrm,49)),%nrm,"DomeProjectile");
   shockwave(VectorAdd(%pos,VectorScale(%nrm,-49)),VectorScale(%nrm,-1),"DomeProjectile");
   }
   RadiusExplosion("", %pos, 250, 2.9, 1000, "", $DamageType::Rifted);
}
