// turretpack.cs - turret pack
//

datablock SensorData(ObeliskTurretSensor)
{
   detects = true;
   detectsUsingLOS = true;
   detectsPassiveJammed = false;
   detectsActiveJammed = false;
   detectsCloaked = false;
   detectionPings = true;
   detectRadius = 350;
};

datablock ShapeBaseImageData(ObeliskTurretDeployableImage)
{
mass = 1;
emap = true;

shapeFile = "stackable1s.dts";
item = ObeliskTurretBasePack;
mountPoint = 1;
offset = "0 -0.2 0";

minDeployDis = 0.5;
maxDeployDis = 5.0;

deployed = ObeliskTurretDeployedBase;
heatSignature = 0;

stateName[0] = "Idle";
stateTransitionOnTriggerDown[0] = "Activate";



stateName[1] = "Activate";
stateScript[1] = "onActivate";
stateTransitionOnTriggerUp[1] = "Idle";

isLarge = true;
maxDepSlope = 360;
deploySound = StationDeploySound;
};

datablock ItemData(ObeliskTurretBasePack)
{
className = Pack;
catagory = "Deployables";
shapeFile = "stackable1s.dts";
mass = 1;
elasticity = 0.2;
friction = 0.6;
pickupRadius = 1;
rotate = false;
image = "ObeliskTurretDeployableImage";
pickUpName = "a Obelisk turret pack";
heatSignature = 0;

computeCRC = true;
emap = true;

};

datablock TurretData(ObeliskTurretDeployedBase) : TurretDamageProfile
{
className = DeployedTurret;
shapeFile = "turret_base_large.dts";

rechargeRate = 0.31;

selfPower = true;

needsPower = false;
mass = 1;
maxDamage = 2.25;
destroyedLevel = 2.25;
disabledLevel = 2.05;
repairRate = 0;
explosion = TurretExplosion;
expDmgRadius = 15.0;
expDamage = 0.7;
expImpulse = 2000.0;

deployedObject = true;

thetaMin = 15;
thetaMax = 140;
//thetaNull = 90;

isShielded = false;
energyPerDamagePoint = 50;
maxEnergy = 150;

humSound = SensorHumSound;
heatSignature = 1;
pausePowerThread = true;

canControl = true;
cmdCategory = "DTactical";
cmdIcon = CMDTurretIcon;
cmdMiniIconName = "commander/MiniIcons/com_turret_grey";
targetNameTag = 'Obelisk Of Light';
targetTypeTag = '';
sensorData = ObeliskTurretSensor;
sensorRadius = 350;
sensorColor = "0 212 45";
powerCount = 1;

firstPersonOnly = true;

debrisShapeName = "debris_generic.dts";
debris = TurretDebris;
};

function ObeliskTurretBasePack::onPickup(%this, %obj, %shape, %amount)
{
// created to prevent console errors
}

function ObeliskTurretDeployableImage::onDeploy(%item, %plyr, %slot)
{
    if($BuildingCount::PowerPlant[%plyr.client.team] <= 0) {
    messageclient(%plyr.client, 'MsgClient', '\c5Tech Error, Power Plant Required.');
    return;
    }
    if($BuildingCount::CommCenter[%plyr.client.team] <= 0) {
    messageclient(%plyr.client, 'MsgClient', '\c5Tech Error, Communications Center Required.');
    return;
    }

%deplObj = Parent::onDeploy(%item, %plyr, %slot);
%origBarrel = %item.item.origBarrel;
if(%origBarrel !$= "")
{
%deplObj.mountImage(%origBarrel, 0, false);
%item.item.origBarrel = "";
}

%deplObj.mountImage("ObeliskBarrelLarge", 0);
%playerVector = vectorNormalize(getWord(%plyr.getEyeVector(),1) SPC -1 * getWord(%plyr.getEyeVector(),0) SPC "0");

%item.surfacenrm = VectorNormalize(%item.surfacenrm);
//echo(%playervector);
if (vAbs(floorVec(%item.surfaceNrm,100)) $= "0 0 1")
		%item.surfaceNrm2 = vectorScale(%playerVector,1);
	else
		%item.surfaceNrm2 = vectorNormalize(vectorCross(%item.surfaceNrm,"0 0 1"));

	%rot = fullRot(%item.surfaceNrm,%item.surfaceNrm2);

%deplObj.setTransform(%item.surfacePt SPC %rot);
//%deplObj.setSelfPowered();
//%deplObj.playThread($PowerThread,"Power");

addDSurface(%item.surface,%deplObj);
addToDeployGroup(%deplObj);
%deplObj.powerFreq = %plyr.powerFreq;
%deplObj.team = %plyr.team;

%deplObj.getDataBlock().onGainPowerEnabled(%deplObj);
%deplObj.getDataBlock().GainPower(%deplObj);
%deplObj.powerCount = 1;

      %count = ClientGroup.getCount();
      for(%i = 0; %i < %count; %i++) {
         %cl = ClientGroup.getObject(%i);
         if(%cl.team == %deplObj.team) {
            messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, Obelisk Of Light.");
         }
      }

    $Power[%deplObj.team] = $Power[%deplObj.team] - 150;
    CheckPowerLowLevel(%deplObj.team);
    $BuildingCount::ObeliskTurret[%deplObj.team]++;
    echo("C&C: Team "@%deplObj.team@" Built an Obelisk at "@%deplObj.getPosition()@".");
}

function ObeliskTurretDeployedBase::onDestroyed(%this,%obj,%prevState) {

      %count = ClientGroup.getCount();
      for(%i = 0; %i < %count; %i++) {
         %cl = ClientGroup.getObject(%i);
         if(%cl.team == %obj.team) {
            messageclient(%cl, 'MsgClient', "\c5Base Update: Building Lost, Obelisk Of Light.");
         }
      }

    $BuildingCount::ObeliskTurret[%obj.team]--;
    $Power[%obj.team] = $Power[%obj.team] + 150;
   CheckPowerGoodLevel(%obj.team);
   $TeamDeployedCount[%obj.team,ObeliskTurretBasePack]--;
   remDSurface(%obj);
   %obj.schedule(500,"delete");
   if($Game::PlayingCnC) {
   $TeamScore[%obj.lastDamagedByTeam] = $TeamScore[%obj.lastDamagedByTeam] + $CNC::Score[Obelisk];
   }
   Parent::onDestroyed(%data,%obj,%prevState);
}

function ObeliskTurretDeployableImage::onMount(%data, %obj, %node) {

}
