//--------------------------------------------------------------------------
// Deployable Generator
//--------------------------------------------------------------------------

datablock ParticleData(NukeIonCannonParticle) {
	dragCoeffiecient     = 0.0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.0;

	lifetimeMS           = 2000;
	lifetimeVarianceMS   = 0;

	textureName          = "particleTest";

	useInvAlpha = false;
	spinRandomMin = -160.0;
	spinRandomMax = 160.0;

    textureName  = "flarebase";

	colors[0]     = "1 0 0";
	colors[1]     = "1 0 0";
	colors[2]     = "1 0 0";
	colors[3]     = "1 0 0";
	sizes[0]      = 10;
	sizes[1]      = 20;
	sizes[2]      = 30;
    sizes[3]      = 30;
	times[0]      = 0.0;
	times[1]      = 0.01;
	times[2]      = 0.02;
    times[3]      = 1;
};

datablock ParticleEmitterData(NukeIonCannonEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;

   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   spinRandomMin   = "200";
   spinRandomMax   = "-200";
   overrideAdvances = false;
   particles = "NukeIonCannonParticle";
};

datablock LinearFlareProjectileData(NukeIonCannonLaser)
{
   projectileShapeName = "plasmabolt.dts";
   scale               = "0.5 0.5 0.5";
   faceViewer          = true;
   directDamage        = 5.9; //die.
   hasDamageRadius     = true;
   indirectDamage      = 8.9;
   damageRadius        = 55;
   kickBackStrength    = 150.0;
   radiusDamageType    = $DamageType::Nuke; //Cause Ze Burn

   explosion           = "MainNuclearExplosion";
   splash              = NuclearSplash;
   baseEmitter         = NukeIonCannonEmitter;
   dryVelocity       = 1000.0;
   wetVelocity       = 1000.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 17000;
   lifetimeMS        = 17000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 0;

   activateDelayMS = -1;

   size[0]           = 0.01;
   size[1]           = 0.01;
   size[2]           = 0.01;

   numFlares         = 1;
   flareColor        = "0 0 1";
   flareModTexture   = "special/stationglow";//"special/sniper00";//"special/stationglow";//"flaremod";
   flareBaseTexture  = "special/lightFalloffMono";//"flarebase";

   hasLight    = false;
   lightRadius = 1.0;
   lightColor  = "0 0 1";

};



///////////////////
//BUILDING
datablock SensorData(TempOfNodSensorObj)
{
   detects = true;
   detectsUsingLOS = true;
   detectsPassiveJammed = true;
   detectsActiveJammed = true;
   detectsCloaked = false;
   detectionPings = true;
   detectRadius = 2000;
};


datablock StaticShapeData(DeployedTempOfNod) : StaticShapeDamageProfile {
   className = Sensor;
   catagory = "Sensors";
   shapeFile = "stackable3m.dts";
   maxDamage = 4.0;
   destroyedLevel = 4.0;
   disabledLevel = 3.85;
   explosion      = ShapeExplosion;
   expDmgRadius = 10.0;
   expDamage = 0.5;
   expImpulse = 2000.0;

   dynamicType = $TypeMasks::StaticShapeObjectType;
   isShielded = true;
   energyPerDamagePoint = 33;
   maxEnergy = 110;
   rechargeRate = 0.31;
   ambientThreadPowered = true;
   humSound = SensorHumSound;

   cmdCategory = "Support";
   cmdIcon = CMDSensorIcon;
   cmdMiniIconName = "commander/MiniIcons/com_sensor_grey";
   targetNameTag = 'Temple Of NOD';
   targetTypeTag = '';
   sensorData = TempOfNodSensorObj;
   sensorRadius = TempOfNodSensorObj.detectRadius;
   sensorColor = "255 194 9";

   debrisShapeName = "debris_generic.dts";
   debris = StaticShapeDebris;
};


datablock ShapeBaseImageData(TempOfNodImage) {
	mass = 20;
	emap = true;
	shapeFile = "stackable1s.dts";
	item = TempOfNodDeployable;
	mountPoint = 1;
	offset = "0 0 0";
	deployed = DeployedTempOfNod;
	heatSignature = 0;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";

	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateTransitionOnTriggerUp[1] = "Idle";

	isLarge = true;
	maxDepSlope = 360;
	deploySound = ItemPickupSound;

	minDeployDis = 2;
	maxDeployDis = 5;
};

datablock ItemData(TempOfNodDeployable) {
	className = Pack;
	catagory = "Deployables";
	shapeFile = "stackable1s.dts";
	mass = 5.0;

	hasLight = true;
	lightType = "PulsingLight";
	lightColor = "0.1 0.8 0.8 1.0";
	lightTime = "1000";
	lightRadius = "3";

	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 3;
	rotate = true;
	image = "TempOfNodImage";
	pickUpName = "a Power Plant";
	heatSignature = 0;
	emap = true;
};

function TempOfNodImage::testNoTerrainFound(%item) {
	// don't check this for non-Landspike turret deployables
}

function TempOfNodDeployable::onPickup(%this, %obj, %shape, %amount) {
	// created to prevent console errors
}

function TempOfNodImage::onDeploy(%item, %plyr, %slot) {

    if($BuildingCount::PowerPlant[%plyr.client.team] <= 0) {
    messageclient(%plyr.client, 'MsgClient', '\c5Tech Error, Power Plant Required.');
    return;
    }
    if($BuildingCount::CommCenter[%plyr.client.team] <= 0) {
    messageclient(%plyr.client, 'MsgClient', '\c5Tech Error, Communications Center Required.');
    return;
    }
    if($CNC::TempleOfNOD[%plyr.client.team] !$= "") {
    messageclient(%plyr.client, 'MsgClient', '\c5Similarity Error, Structure Already Exists.');
    return;
    }

	%className = "StaticShape";

	%playerVector = vectorNormalize(getWord(%plyr.getEyeVector(),1) SPC -1 * getWord(%plyr.getEyeVector(),0) SPC "0");

	if (vAbs(floorVec(%item.surfaceNrm,100)) $= "0 0 1")
		%item.surfaceNrm2 = vectorScale(%playerVector,-1);
	else
		%item.surfaceNrm2 = vectorNormalize(vectorCross(%item.surfaceNrm,"0 0 1"));

	%rot = fullRot(%item.surfaceNrm,%item.surfaceNrm2);

	%item.surfacePt = vectorAdd(%item.surfacePt,vectorScale(vectorNormalize(vectorCross(%item.surfaceNrm,%item.surfaceNrm2)),2));

	%deplObj = new (%className)() {
		dataBlock = DeployedTempOfNod;
        scale = "10 10 10";
		deployed = true;
	};

	// set orientation
	%deplObj.setTransform(%item.surfacePt SPC %rot);

	// set team, owner, and handle
	%deplObj.team = %plyr.client.Team;

	// set power frequency
	%deplObj.powerFreq = %plyr.powerFreq;

	// set power
	%deplObj.setSelfPowered();

	// set the sensor group if it needs one
	if (%deplObj.getTarget() != -1)
		setTargetSensorGroup(%deplObj.getTarget(), %plyr.client.team);

	// place the deployable in the MissionCleanup/Deployables group (AI reasons)
	addToDeployGroup(%deplObj);

	//let the AI know as well...
	AIDeployObject(%plyr.client, %deplObj);

	// play the deploy sound
	serverPlay3D(%item.deploySound, %deplObj.getTransform());

	// increment the team count for this deployed object
	$TeamDeployedCount[%plyr.team, %item.item]++;

	addDSurface(%item.surface,%deplObj);

	%deplObj.playThread($PowerThread,"Power");

    $BuildingCount::TempOfNod[%deplObj.team]++;
    $Power[%deplObj.team] = $Power[%deplObj.team] - 250; //Add 250 Power From The Team Count
    %deplObj.team.TempOfNodCount++;

	// take the deployable off the player's back and out of inventory
	%plyr.unmountImage(%slot);
	%plyr.decInventory(%item.item, 1);

	// add to power list
	$PowerList = listAdd($PowerList,%deplObj,-1);

      %count = ClientGroup.getCount();
      for(%i = 0; %i < %count; %i++) {
         %cl = ClientGroup.getObject(%i);
         if(%cl.team == %deplObj.team) {
         messageclient(%cl, 'MsgClient', "\c5Base Update: Construction Complete, Temple Of NOD.");
         messageclient(%cl, 'MsgClient', "\c5Superweapon Update: Nuclear Missile Charging.");
         }
         else {
         messageclient(%cl, 'MsgClient', "\c5Superweapon Update: WARNING: Temple Of NOD Detected.");
         }
      }
    CheckPowerLowLevel(%deplObj.team);
    $CNC::TempleOfNOD[%deplObj.team] = %deplObj;   //one per team
    %deplObj.canFireNuke = 0;
    %deplObj.NukeSched = schedule(360000,0,"NukeReady",%deplObj);
    $SuperweaponTimer::Nuke[%deplObj.team] = 360;
    schedule(1000,0,"DoNukeTimer", %deplObj);
    echo("C&C: Team "@%deplObj.team@" Built a Temple Of NOD at "@%deplObj.getPosition()@".");
	return %deplObj;
}

function DoNukeTimer(%obj) {
   if(!isObject(%obj)) {
      $SuperweaponTimer::Nuke[%obj.team] = 360;
      return;
   }
   if($SuperweaponTimer::Nuke[%obj.team] == 0) {
      schedule(1000,0,"DoNukeTimer", %obj);
      return;
   }
   if($Power[%obj.team] < 0) {
      schedule(1000,0,"DoNukeTimer", %obj);
      return;
   }
   $SuperweaponTimer::Nuke[%obj.team]--;
   schedule(1000,0,"DoNukeTimer", %obj);
}

function DeployedTempOfNod::onDestroyed(%this,%obj,%prevState) {

      %count = ClientGroup.getCount();
      for(%i = 0; %i < %count; %i++) {
         %cl = ClientGroup.getObject(%i);
         if(%cl.team == %obj.team) {
         messageclient(%cl, 'MsgClient', "\c5Base Update: Building Lost, Temple Of NOD.");
         messageclient(%cl, 'MsgClient', "\c5Superweapon Update: Nuclear Missile Disabled.");
         }
         else {
         messageclient(%cl, 'MsgClient', "\c5Superweapon Update: Temple Of NOD Destroyed.");
         }
      }

   cancel(%obj.NukeSched);
   $SuperweaponTimer::Nuke[%obj.team] = 360;
   $CNC::TempleOfNOD[%obj.team] = "";
   $BuildingCount::TempOfNod[%obj.team]--;
   $TeamDeployedCount[%obj.team,TempOfNodDeployable]--;
   $Power[%obj.team] = $Power[%obj.team] + 250; //Remove 250 Power From The Team Count
   CheckPowerGoodLevel(%obj.team);
   %obj.team.TempOfNodCount--;
   remDSurface(%obj);
   %obj.schedule(500,"delete");
   if($Game::PlayingCnC) {
   $TeamScore[%obj.lastDamagedByTeam] = $TeamScore[%obj.lastDamagedByTeam] + $CNC::Score[TempleOfNod];
   }
   Parent::onDestroyed(%data,%obj,%prevState);
}

function TempOfNodImage::onMount(%data,%obj,%node) {
	%obj.hasGen = true; // set for gencheck
}

function TempOfNodImage::onUnmount(%data,%obj,%node) {
	%obj.hasGen = "";
}

//NUCLEAR MISSILE
function NukeReady(%obj) {
   %count = ClientGroup.getCount();
   for(%i = 0; %i < %count; %i++) {
      %cl = ClientGroup.getObject(%i);
      if(%cl.team == %obj.team) {
      messageclient(%cl, 'MsgClient', "\c5Superweapon Update: Nuclear Missile Ready.");
      }
      else {
      messageclient(%cl, 'MsgClient', "\c5Superweapon Update: WARNING: ENEMY Nuclear Missile Ready.");
      }
   }
   %obj.canFireNuke = 1;
}

//Prep & Sound
datablock EffectProfile(NukePrepEffect)
{
   effectname = "C&C/TempleOfNOD/NukePrep";
   minDistance = 1;
   maxDistance = 500;
};

datablock AudioProfile(NukePrepSound)
{
   filename    = "fx/vehicles/tank_activate.wav";
   description = AudioExplosion3d;
   effect = NukePrepEffect;
};

function PrepNuke(%obj, %pos) {
   if(!isObject(%obj)) {
   return;
   }
   %obj.canFireNuke = 0;
   %obj.NukeSched = schedule(360000,0,"NukeReady",%obj);
   $SuperweaponTimer::Nuke[%obj.team] = 360;
   %count = ClientGroup.getCount();
   for(%i = 0; %i < %count; %i++) {
      %cl = ClientGroup.getObject(%i);
      if(%cl.team == %obj.team) {
      messageclient(%cl, 'MsgClient', "\c5Nuclear Missile Preping.");
      }
      else {
      messageclient(%cl, 'MsgClient', "\c5WARNING: Nuclear Missile Targeted. ~wfx/misc/red_alert_short.wav");
      }
   }
   serverPlay3D(NukePrepSound, %obj.position);
   schedule(7500,0,"FireFakeNuke",%obj, %pos);
   schedule(12000,0,"NukeDrop",%obj, %pos);
}

//Fire & Sound
datablock EffectProfile(NukeFireEffect)
{
   effectname = "C&C/TempleOfNOD/NukeFire";
   minDistance = 1;
   maxDistance = 3000;
};

datablock AudioProfile(NukeFireSound)
{
   filename    = "fx/Bonuses/high-level4-blazing.wav";
   description = AudioExplosion3d;
   effect = NukeFireEffect;
};

function FireFakeNuke(%obj, %pos) {
   if(!isObject(%obj)) {
   return;
   }
   %count = ClientGroup.getCount();
   for(%i = 0; %i < %count; %i++) {
      %cl = ClientGroup.getObject(%i);
      if(%cl.team == %obj.team) {
      messageclient(%cl, 'MsgClient', "\c5Nuclear Missile Launched.");
      }
      else {
      messageclient(%cl, 'MsgClient', "\c5WARNING: Nuclear Missile Launched. ~wfx/misc/red_alert.wav");
      }
   }
   serverPlay3D(NukeFireSound, %obj.position);
   %pfake = new (LinearFlareProjectile)() {
   dataBlock = NukeIonCannonLaser;
   initialDirection = "0 0 100";
   initialPosition = vectorAdd(%obj.getPosition(), "0 0 25");
   sourceObject = %obj;
   damageFactor = 1;
   };
   MissionCleanup.Add(%pfake);
}

function NukeDrop(%obj, %pos) {
   %nooke = new (LinearFlareProjectile)() {
   dataBlock = NukeIonCannonLaser;
   initialDirection = "0 0 -100";
   initialPosition = vectorAdd(%pos, "0 0 500");
//   sourceObject = %obj;
   damageFactor = 1;
   };
   MissionCleanup.Add(%nooke);
}
