// ------------------------------------------------------------------
// SHIELD PACK
// can be used by any armor type
// while activated, absorbs damage at cost of energy

datablock ShapeBaseImageData(ShieldGenPackImage)
{
   shapeFile = "pack_upgrade_shield.dts";
   item = ShieldGenPack;
   mountPoint = 1;
   offset = "0 0 0";

   usesEnergy = true;
   minEnergy = 3;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";

	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateSequence[1] = "fire";
	stateSound[1] = ShieldPackActivateSound;
	stateTransitionOnTriggerUp[1] = "Deactivate";
   stateTransitionOnNoAmmo[1] = "Deactivate";

	stateName[2] = "Deactivate";
	stateScript[2] = "onDeactivate";
	stateTransitionOnTimeout[2] = "Idle";
};

datablock ItemData(ShieldGenPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "pack_upgrade_shield.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "ShieldGenPackImage";
	pickUpName = "a shield generator";

   computeCRC = true;
};

function ShieldGenPackImage::onMount(%data, %obj, %node)
{
}

function ShieldGenPackImage::onUnmount(%data, %obj, %node)
{
	%obj.setImageTrigger(%node, false);
   %obj.isShielded2 = "";
   %obj.usingShieldGen = false;
}

function ShieldGenPackImage::onActivate(%data, %obj, %slot)
{
   messageClient(%obj.client, 'MsgShieldPackOn', '\c2Shield generator on.');
   %obj.usingShieldGen = true;
   %obj.isShielded2 = true;
   %obj.setMoveState(true); //no moving while protected
   ShieldEffectLoop(%obj);
   commandToClient( %obj.client, 'setShieldIconOn' );
}

function ShieldGenPackImage::onDeactivate(%data, %obj, %slot)
{
   messageClient(%obj.client, 'MsgShieldPackOff', '\c2Shield generator off.');
	%obj.setImageTrigger(%slot,false);
   %obj.isShielded2 = "";
   %obj.setMoveState(false);
   %obj.usingShieldGen = false;
   commandToClient( %obj.client, 'setShieldIconOff' );
}

function ShieldEffectLoop(%player) {
if(!%player.isShielded2) {
return;
}
if(!isObject(%player) || %player.getState() $= "dead") {
return;
}
%player.playShieldEffect("1 1 1");
schedule(100,0,"ShieldEffectLoop",%player);
}

function ShieldGenPack::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

