//--------------------------------------------------------------------------
// Plasma Turret
// 
// 
//--------------------------------------------------------------------------

//--------------------------------------------------------------------------
// Projectile
//--------------------------------------

datablock SniperProjectileData(LaserCannonBeam)
{
   directDamage        = 0.6;
   hasDamageRadius     = true;
   indirectDamage      = 4.0;
   damageRadius        = 10.0;
   velInheritFactor    = 0.0;
   kickBackStrength    = 0;
   sound 				  = SniperRifleProjectileSound;
   explosion           = "BlasterExplosion";
   splash              = SniperSplash;
   directDamageType    = $DamageType::Explosion;

   maxRifleRange       = 1000;
   rifleHeadMultiplier = 1.3;
   beamColor           = "1 0 0";
   fadeTime            = 1.5;

   startBeamWidth		  = 2.2;
   endBeamWidth 	     = 2.2;
   pulseBeamWidth 	  = 0.15;
   beamFlareAngle 	  = 3.0;
   minFlareSize        = 0.0;
   maxFlareSize        = 400.0;
   pulseSpeed          = 90.0;
   pulseLength         = 0.150;

   lightRadius         = 1.0;
   lightColor          = "1 0 0";

   useInvAlpha =  false;
   textureName[0]      = "special/flare";
   textureName[1]      = "special/nonlingradient";
   textureName[2]      = "special/shieldenvmap";
   textureName[3]      = "special/shieldenvmap";
   textureName[4]      = "special/shieldenvmap";
   textureName[5]      = "special/shieldenvmap";
   textureName[6]      = "special/shieldenvmap";
   textureName[7]      = "special/shieldenvmap";
   textureName[8]      = "special/shieldenvmap";
   textureName[9]      = "special/shieldenvmap";
   textureName[10]     = "special/shieldenvmap";
   textureName[11]     = "special/shieldenvmap";
};

//--------------------------------------------------------------------------
// Plasma Turret Image
//--------------------------------------------------------------------------

datablock TurretImageData(LaserBarrelLarge)
{
   shapeFile = "turret_mortar_large.dts";
   // ---------------------------------------------
   // z0dd - ZOD, 5/8/02. Incorrect parameter value
   //item      = PlasmaBarrelLargePack;
   item = PlasmaBarrelPack;

   projectile = LaserCannonBeam;
   projectileType = SniperProjectile;
   usesEnergy = true;
   fireEnergy = 10;
   minEnergy = 10;
   emap = true;

   // Turret parameters
   activationMS      = 1000;
   deactivateDelayMS = 1500;
   thinkTimeMS       = 200;
   degPerSecTheta    = 300;
   degPerSecPhi      = 500;
   attackRadius      = 150;

   // State transitions
   stateName[0]                  = "Activate";
   stateTransitionOnNotLoaded[0] = "Dead";
   stateTransitionOnLoaded[0]    = "ActivateReady";

   stateName[1]                  = "ActivateReady";
   stateSequence[1]              = "Activate";
   stateSound[1]                 = PBLSwitchSound;
   stateTimeoutValue[1]          = 1;
   stateTransitionOnTimeout[1]   = "Ready";
   stateTransitionOnNotLoaded[1] = "Deactivate";
   stateTransitionOnNoAmmo[1]    = "NoAmmo";

   stateName[2]                    = "Ready";
   stateTransitionOnNotLoaded[2]   = "Deactivate";
   stateTransitionOnTriggerDown[2] = "Fire";
   stateTransitionOnNoAmmo[2]      = "NoAmmo";

   stateName[3]                = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3]        = 0.3;
   stateFire[3]                = true;
   stateRecoil[3]              = LightRecoil;
   stateAllowImageChange[3]    = false;
   stateSequence[3]            = "Fire";
   stateSound[3]               = HeavyCGTurretFireSound;
   stateScript[3]              = "onFire";

   stateName[4]                  = "Reload";
   stateTimeoutValue[4]          = 1.5;
   stateAllowImageChange[4]      = false;
   stateSequence[4]              = "Reload";
   stateTransitionOnTimeout[4]   = "Ready";
   stateTransitionOnNotLoaded[4] = "Deactivate";
   stateTransitionOnNoAmmo[4]    = "NoAmmo";

   stateName[5]                = "Deactivate";
   stateSequence[5]            = "Activate";
   stateDirection[5]           = false;
   stateTimeoutValue[5]        = 1;
   stateTransitionOnLoaded[5]  = "ActivateReady";
   stateTransitionOnTimeout[5] = "Dead";

   stateName[6]               = "Dead";
   stateTransitionOnLoaded[6] = "ActivateReady";

   stateName[7]             = "NoAmmo";
   stateTransitionOnAmmo[7] = "Reload";
   stateSequence[7]         = "NoAmmo";
};

function LaserBarrelLarge::OnFire(%data, %obj, %slot) {     //Needs This.
%p = new (SniperProjectile)() {
dataBlock = LaserCannonBeam;
initialDirection = %obj.getMuzzleVector(%slot);
initialPosition = %obj.getMuzzlePoint(%slot);
sourceObject = %obj;
damageFactor = 1;
sourceSlot = %slot;
};
%p.setEnergyPercentage(100);
MissionCleanup.Add(%p);
}

function LaserCannonBeam::onCollision(%data,%projectile,%targetObject,%modifier,%position,%normal) {
   %TargetObject.damage(0, %TargetObject.position, 0.6, $DamageType::Explosion);
}

