//--------------------------------------
// Projectile
//--------------------------------------
datablock TargetProjectileData(GDIIonCannonTargeter)
{
   directDamage        	= 0.0;
   hasDamageRadius     	= false;
   indirectDamage      	= 0.0;
   damageRadius        	= 0.0;
   velInheritFactor    	= 1.0;

   maxRifleRange       	= 25;
   beamColor           	= "0.1 0.1 1.0";

   startBeamWidth			= 0.20;
   pulseBeamWidth 	   = 0.15;
   beamFlareAngle 	   = 3.0;
   minFlareSize        	= 0.0;
   maxFlareSize        	= 400.0;
   pulseSpeed          	= 6.0;
   pulseLength         	= 0.150;

   textureName[0]      	= "special/nonlingradient";
   textureName[1]      	= "special/flare";
   textureName[2]      	= "special/pulse";
   textureName[3]      	= "special/expFlare";
   beacon               = true;
};

datablock TargetProjectileData(GDIAirstrikeTargeter)
{
   directDamage        	= 0.0;
   hasDamageRadius     	= false;
   indirectDamage      	= 0.0;
   damageRadius        	= 0.0;
   velInheritFactor    	= 1.0;

   maxRifleRange       	= 75;
   beamColor           	= "0.1 0.1 1.0";

   startBeamWidth			= 0.20;
   pulseBeamWidth 	   = 0.15;
   beamFlareAngle 	   = 3.0;
   minFlareSize        	= 0.0;
   maxFlareSize        	= 400.0;
   pulseSpeed          	= 6.0;
   pulseLength         	= 0.150;

   textureName[0]      	= "special/nonlingradient";
   textureName[1]      	= "special/flare";
   textureName[2]      	= "special/pulse";
   textureName[3]      	= "special/expFlare";
   beacon               = true;
};

datablock TargetProjectileData(NODNukeTargeter)
{
   directDamage        	= 0.0;
   hasDamageRadius     	= false;
   indirectDamage      	= 0.0;
   damageRadius        	= 0.0;
   velInheritFactor    	= 1.0;

   maxRifleRange       	= 25;
   beamColor           	= "1.0 0.1 0.1";

   startBeamWidth			= 0.20;
   pulseBeamWidth 	   = 0.15;
   beamFlareAngle 	   = 3.0;
   minFlareSize        	= 0.0;
   maxFlareSize        	= 400.0;
   pulseSpeed          	= 6.0;
   pulseLength         	= 0.150;

   textureName[0]      	= "special/nonlingradient";
   textureName[1]      	= "special/flare";
   textureName[2]      	= "special/pulse";
   textureName[3]      	= "special/expFlare";
   beacon               = true;
};

datablock TargetProjectileData(NPARiftTargeter)
{
   directDamage        	= 0.0;
   hasDamageRadius     	= false;
   indirectDamage      	= 0.0;
   damageRadius        	= 0.0;
   velInheritFactor    	= 1.0;

   maxRifleRange       	= 50;  //NPA has it harder
   beamColor           	= "0.0 1.1 0.1";

   startBeamWidth			= 0.20;
   pulseBeamWidth 	   = 0.15;
   beamFlareAngle 	   = 3.0;
   minFlareSize        	= 0.0;
   maxFlareSize        	= 400.0;
   pulseSpeed          	= 6.0;
   pulseLength         	= 0.150;

   textureName[0]      	= "special/nonlingradient";
   textureName[1]      	= "special/flare";
   textureName[2]      	= "special/pulse";
   textureName[3]      	= "special/expFlare";
   beacon               = true;
};


//--------------------------------------
// Rifle and item...
//--------------------------------------
datablock ItemData(BeaconLaser)
{
   className    = Weapon;
   catagory     = "Spawn Items";
   shapeFile    = "weapon_targeting.dts";
   image        = BeaconLaserImage;
   mass         = 1;
   elasticity   = 0.2;
   friction     = 0.6;
   pickupRadius = 2;
	pickUpName = "a targeting laser rifle";

   computeCRC = true;

};

datablock ShapeBaseImageData(BeaconLaserImage)
{
   className = WeaponImage;

   shapeFile = "weapon_targeting.dts";
   item = BeaconLaser;
   offset = "0 0 0";

   projectile = BasicTargeter;
   projectileType = TargetProjectile;
   deleteLastProjectile = true;

	usesEnergy = true;
	minEnergy = 3;

   stateName[0]                     = "Activate";
   stateSequence[0]                 = "Activate";
	stateSound[0]                    = TargetingLaserSwitchSound;
   stateTimeoutValue[0]             = 0.5;
   stateTransitionOnTimeout[0]      = "ActivateReady";

   stateName[1]                     = "ActivateReady";
   stateTransitionOnAmmo[1]         = "Ready";
   stateTransitionOnNoAmmo[1]       = "NoAmmo";

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";

   stateName[3]                     = "Fire";
	stateEnergyDrain[3]              = 3;
   stateFire[3]                     = true;
   stateAllowImageChange[3]         = false;
   stateScript[3]                   = "onFire";
   stateTransitionOnTriggerUp[3]    = "Deconstruction";
   stateTransitionOnNoAmmo[3]       = "Deconstruction";
   stateSound[3]                    = TargetingLaserPaintSound;

   stateName[4]                     = "NoAmmo";
   stateTransitionOnAmmo[4]         = "Ready";

   stateName[5]                     = "Deconstruction";
   stateScript[5]                   = "deconstruct";
   stateTransitionOnTimeout[5]      = "Ready";
};

function PositionChecker(%obj){
   if (!isObject(%obj.lastProjectile)) {
      return;
   }
   if (!isObject(%obj)) {
      return;
   }
   //check active
   if(%obj.isIonBeacon) {
      if(!isObject($CNC::IonControl[%obj.team])) {
      bottomPrint(%obj.client,"Ion Control Not Detected.",3,3);
      return;
      }
      if($CNC::IonControl[%obj.team].canFireIonCannon == 0) {
      bottomPrint(%obj.client,"Ion Cannon Charging.",3,3);
      return;
      }
   }
   else if(%obj.isAirstrikeBeacon) {
      if($BuildingCount::CommCenter[%obj.team] == 0) {
      bottomPrint(%obj.client,"Communications Center Not Detected.",3,3);
      return;
      }
      if($Superweapon::AirstrikeReady[%obj.team] == 0) {
      bottomPrint(%obj.client,"Airstrike Charging.",3,3);
      return;
      }
   }
   else if(%obj.isRiftBeacon) {
      if(!isObject($CNC::EnrichGenerator[%obj.team])) {
      bottomPrint(%obj.client,"Enrich Generator Not Detected.",3,3);
      return;
      }
      if($CNC::EnrichGenerator[%obj.team].canFireRift == 0) {
      bottomPrint(%obj.client,"Spacious Rift Charging.",3,3);
      return;
      }
   }
   else {
      if(!isObject($CNC::TempleOfNOD[%obj.team])) {
      bottomPrint(%obj.client,"Temple Of Nod Not Detected.",3,3);
      return;
      }
      if($CNC::TempleOfNOD[%obj.team].canFireNuke == 0) {
      bottomPrint(%obj.client,"Nuclear Missile Charging.",3,3);
      return;
      }
   }
   if (%obj.lastprojopos $="") {
      %obj.lastprojopos=%obj.lastProjectile.getposition();
      schedule(100,0,PositionChecker,%obj);
      return;
   }
   %lpos = %obj.lastprojopos;
   %pos = %obj.lastProjectile.getposition();
   if(getword(%pos,0)>getword(%lpos,0)-5 && getword(%pos,0)<getword(%lpos,0)+5) {
      if(getword(%pos,1)>getword(%lpos,1)-5 && getword(%pos,1)<getword(%lpos,1)+5) {
         if (%obj.poscheked > ($CNC::BeaconTimer * 10)) {
            //Fire
            if(%obj.isIonBeacon) {
            PrepIonCannon($CNC::IonControl[%obj.team], %obj.lastProjectile.getposition());
            $CNC::IonControl[%obj.team].canFireIonCannon = 0;
            bottomPrint(%obj.client,"Ion Control Contacted, Coordinates Sent.",3,3);
            }
            else if(%obj.isAirstrikeBeacon) {
            PrepAirRaid(%obj, %obj.lastProjectile.getposition());
            $Superweapon::AirstrikeReady[%obj.team] = 0;
            bottomPrint(%obj.client,"Communications Center Contacted, Coordinates Sent.",3,3);
            }
            else if(%obj.isRiftBeacon) {
            PrepRift($CNC::EnrichGenerator[%obj.team], %obj.lastProjectile.getposition());
            $CNC::EnrichGenerator[%obj.team].canFireRift = 0;
            bottomPrint(%obj.client,"Enrich Generator Controls Contacted, Coordinates Sent.",3,3);
            }
            else {
            PrepNuke($CNC::TempleOfNOD[%obj.team], %obj.lastProjectile.getposition());
            $CNC::TempleOfNOD[%obj.team].canFireNuke = 0;
            bottomPrint(%obj.client,"Temple Of Nod Contacted, Coordinates Sent.",3,3);
            }
            //End
            %obj.lastprojopos="";
            if (isObject(%obj.lastProjectile))
               %obj.lastProjectile.schedule(200, "delete");
            %obj.poscheked=0;
            return;
            }
         else
            if (%obj.poscheked$="") {
               %obj.poscheked=0;
               }
            else {
               %obj.poscheked++;
            }
        }
     }
     else {
        %obj.poscheked=0;
     }
     %obj.lastprojopos=%obj.lastProjectile.getposition();
     schedule(100,0,PositionChecker,%obj);
}


function BeaconLaserImage::onFire(%data,%obj,%slot) {
   if(%obj.isIonBeacon) {
      %p = new (TargetProjectile)() {
         dataBlock = GDIIonCannonTargeter;
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition = %obj.getMuzzlePoint(%slot);
         sourceSlot = %obj.sourceslot;
         sourceobject = %obj;
      };
   }
   else if(%obj.isAirstrikeBeacon) {
      %p = new (TargetProjectile)() {
         dataBlock = GDIAirstrikeTargeter;
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition = %obj.getMuzzlePoint(%slot);
         sourceSlot = %obj.sourceslot;
         sourceobject = %obj;
      };
   }
   else if(%obj.isRiftBeacon) {
      %p = new (TargetProjectile)() {
         dataBlock = NPARiftTargeter;
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition = %obj.getMuzzlePoint(%slot);
         sourceSlot = %obj.sourceslot;
         sourceobject = %obj;
      };
   }
   else {
      %p = new (TargetProjectile)() {
         dataBlock = NODNukeTargeter;
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition = %obj.getMuzzlePoint(%slot);
         sourceSlot = %obj.sourceslot;
         sourceobject = %obj;
      };
   }
   MissionCleanup.add(%p);
   %obj.lastProjectile = %p;
   bottomPrint(%obj.client,"Maintain target position until target coordinates are sent.",3,3);
   schedule(100,0,PositionChecker,%obj);
}

function BeaconLaserImage::deconstruct(%data, %obj, %slot) {
%obj.lastprojopos="";
%obj.poscheked=0;
if (isObject(%obj.lastProjectile))
   %obj.lastProjectile.delete();
}
