//ALL CREDIT TO THE HALO MOD
// ORIGINALLY CODED BY: SoldierOfLight

datablock AudioProfile(GruntSound)
{
   filename = "fx/environment/growl5.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(BeamExpSound)
{
   filename = "fx/vehicles/shrike_blaster_projectile_impact.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock ExplosionData(ESwordExplosion)
{
   explosionShape = "disc_explosion.dts";
   faceViewer           = true;
   explosionscale = 0.1;
   scale = 0.1;
   soundProfile = BeamExpSound;

   playSpeed = 2;

   sizes[0] = 0.1;
   sizes[1] = 0.1;
   times[0] = 0.0;
   times[1] = 1.0;
};

datablock TracerProjectileData(ESwordExpCreater)
{
	className = "TracerProjectileData";
	Explosion = "ESwordExplosion";
	dryVelocity = "0.1";
	wetVelocity = "0.1";
	fizzleTimeMS = "32";
	lifetimeMS = "32";
	explodeOnDeath = "1";
	crossSize = "0.1";
	renderCross = "0";
        isFXUnit = "1";
};

datablock TargetProjectileData(ESwordBeam)
{
   directDamage        	= 0.0;
   hasDamageRadius     	= false;
   indirectDamage      	= 0.0;
   damageRadius        	= 0.0;
   velInheritFactor    	= 1.0;

   maxRifleRange       	= 1.5;
   beamColor           	= "0 1 1";

   startBeamWidth		= 0.1;
   pulseBeamWidth 	    = 0.1;
   beamFlareAngle 	    = 3.0;
   minFlareSize        	= 0.0;
   maxFlareSize        	= 0.0;
   pulseSpeed          	= 0.0;
   pulseLength         	= 0.0;

   textureName[0]      	= "special/nonlingradient";
   textureName[1]      	= "special/flare";
   textureName[2]      	= "special/pulse";
   textureName[3]      	= "skins/glow_Red";
};

ESwordBeam.maxRifleRange = 1.5;

datablock ItemData(ESword)
{
   className = Weapon;
   catagory = "Spawn Items";
   //$$ TODO - real shape file
   shapeFile = "stackable4m.dts";
   image = ESwordImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a beam sword";

   computeCRC = true;
   emap=true;
};

datablock ShapeBaseImageData(ESwordImage)
{
   className = WeaponImage;
   shapeFile = "turret_muzzlepoint.dts";
   offset = "0.1 0.7 0.2";
   item = ESword;
   emap = true;
   projectile = EnergyBolt;
   projectileType = EnergyProjectile;

   // State Data
   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.2;
   stateSequence[0] = "Activate";
   stateSound[0] = ChaingunSwitchSound;

   stateName[1] = "ActivateReady";
   stateTimeoutValue[1] = 0.01;
   stateScript[1] = "onActivateReady";
   stateTransitionOnTimeout[1] = "Ready";

   stateName[2] = "Ready";
   stateScript[2] = "onReady";
   stateTransitionOnTriggerDown[2] = "Fire";

   stateName[3] = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateFire[3] = true;
   stateAllowImageChange[3] = false;
   stateScript[3] = "onFire";

   stateName[4]                  = "Reload";
   stateTransitionOnTimeout[4]   = "Ready";
   stateTimeoutValue[4]          = 1.5;
   stateAllowImageChange[4]      = false;
   stateSound[3] = GruntSound;
};

datablock ShapeBaseImageData(ESwordImage2)
{
   shapeFile = "weapon_energy_vehicle.dts";
   offset = "0.1 0.2 0";
   rotation = "1 0 0 -10";
};

datablock ShapeBaseImageData(ESwordImage3)
{
   shapeFile = "weapon_energy_vehicle.dts";
   offset = "0.1 0.2 0.1";
   rotation = "-1.10478e-07 0.996195 -0.0871558 180";
};

function ESwordImage::onMount(%data,%obj,%slot)
{
   Parent::onMount(%data,%obj,%slot);
   %obj.mountImage(ESwordImage2,4);
   %obj.mountImage(ESwordImage3,5);
   %obj.usingEsword = 1;
}

function ESwordImage::onUnmount(%data,%obj,%slot)
{
   Parent::onUnmount(%data,%obj,%slot);
   %obj.unMountImage(4);
   %obj.unMountImage(5);
   %obj.usingEsword = 0;
   cancel(%obj.ESwordloop);
   cancel(%obj.ESwordcloakloop);
   if(isObject(%obj.beam1))
   {
      %obj.beam1.delete();
      %obj.beam1 = "";
   }
   if(isObject(%obj.beam2))
   {
      %obj.beam2.delete();
      %obj.beam2 = "";
   }
}

function ESwordImage::onActivateReady(%data,%obj,%slot) //small explosion
{
   %p = new TracerProjectile()
   {
      datablock = "ESwordExpCreater";
      initialPosition = %obj.getMuzzlePoint(%slot);
      initialDirection = %obj.getMuzzleVector(%slot);
   };
}

function ESwordImage::onReady(%data,%obj,%slot) //create beams
{
   ESwordloop(%obj);
   CheckCloakLoop(%obj);
}

function CheckCloakLoop(%obj) {
   if(!isObject(%obj) || %obj.getState() $= "dead") {
   return;
   }
   if(%obj.usingEsword == 1) {
      if(%obj.isCloaked() && %obj.client.Arby1) {
         if(isObject(%obj.beam1)) {
            %obj.beam1.delete();
            %obj.beam1 = "";
         }
         if(isObject(%obj.beam2)) {
            %obj.beam2.delete();
            %obj.beam2 = "";
         }
      }
   }
   %obj.ESwordcloakloop = schedule(25,0,CheckCloakLoop,%obj);
}

function ESwordLoop(%obj)
{
   if(!isObject(%obj) || %obj.getState() $= "dead") {
   return;
   }
   if(%obj.usingEsword == 0)
   {
      if(isObject(%obj.beam1))
         %obj.beam1.delete();
      if(isObject(%obj.beam2))
         %obj.beam2.delete();
      return;
   }
   %vec1 = %obj.getMuzzleVector(4);
   %vec2 = %obj.getMuzzleVector(5);
   %vec = %obj.getMuzzleVector(0);
   %vec2d = getWords(%vec,0,1) SPC "0";
   %left = vectorCross(%vec2d,"0 0 1");
   %up = vectorCross(%vec,%left);
   %up = vectorScale(%up,0.2);
   %down = vectorScale(%up,-1);
   %pos1 = %obj.getMuzzlePoint(5);
   %pos2 = %obj.getMuzzlePoint(4);
   %dir1 = vectorAdd(%vec1,%down);
   %dir2 = vectorAdd(%vec2,%up);
   if(!isObject(%obj.beam1) && !%obj.isCloaked())
   {
      %obj.beam1 = new TargetProjectile()
      {
         datablock = "ESwordBeam";
         initialPosition = %pos1;
         initialDirection = %dir1;
         sourceSlot = 4;
         sourceObject = %obj;
      };
   }
   if(!isObject(%obj.beam2) && !%obj.isCloaked())
   {
      %obj.beam2 = new TargetProjectile()
      {
         datablock = "ESwordBeam";
         initialPosition = %pos2;
         initialDirection = %dir2;
         sourceSlot = 5;
         sourceObject = %obj;
      };
   }
   %obj.ESwordloop = schedule(25,0,ESwordloop,%obj);
}

function ESwordImage::onFire(%data,%obj,%slot) //apply damage
{
   if(%obj.isCloaked()) {
      %obj.setCloaked(false);
      %obj.reCloak = %obj.schedule(2500, "setCloaked", true );
   }
   %vec = %obj.getMuzzleVector(%slot);
   %pos = %obj.getMuzzlePoint(%slot);
   %vec = vectorScale(%vec,1.5);
   %end = vectorAdd(%pos,%vec);
   %mask = $TypeMasks::VehicleObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticShapeObjectType;
   initContainerRadiusSearch(%end,1.0,%mask);
   while((%target = containerSearchNext()) != 0)
   {
      if(%target == %obj) //you can never be too careful
         return;
      %target.damage(%obj,%target.getWorldBoxCenter(),0.4,$DamageType::ESword);
      if(%obj.client.Arby1 == 1) {
      //add a little more damage
      %target.damage(%obj,%target.getWorldBoxCenter(),0.2,$DamageType::ESword);
      }
      if(%obj.client.Arby3 == 2) {
      //Do the kill
      %target.damage(%obj,%target.getWorldBoxCenter(),0.6,$DamageType::ESword);
      }
      %p = new TracerProjectile()
      {
         datablock = "ESwordExpCreater";
         initialPosition = %target.getPosition();
         initialDirection = %obj.getMuzzleVector(%slot); //who cares?
      };
   }
   //play anim
//   %obj.disableMove(true); //don't screw up the kewl animation ;)
//   %obj.schedule(500,disableMove,false);
}

function ESword::onThrow(%data,%obj,%plyr)
{
   %pos = %obj.getPosition();
   %p = new TracerProjectile()
   {
      datablock = "ESwordExpCreater";
      initialPosition = %pos;
      initialDirection = "0 0 1";
   };
}
